// Compiled by ClojureScript 1.9.229 {}
goog.provide('re_frame.fx');
goog.require('cljs.core');
goog.require('re_frame.router');
goog.require('re_frame.db');
goog.require('re_frame.interceptor');
goog.require('re_frame.interop');
goog.require('re_frame.events');
goog.require('re_frame.registrar');
goog.require('re_frame.loggers');
re_frame.fx.kind = new cljs.core.Keyword(null,"fx","fx",-1237829572);
if(cljs.core.truth_(re_frame.registrar.kinds.call(null,re_frame.fx.kind))){
} else {
throw (new Error("Assert failed: (re-frame.registrar/kinds kind)"));
}
re_frame.fx.register = cljs.core.partial.call(null,re_frame.registrar.register_handler,re_frame.fx.kind);
/**
 * An interceptor which actions a `context's` (side) `:effects`.
 * 
 *   For each key in the `:effects` map, call the `effects handler` previously
 *   registered using `reg-fx`.
 * 
 *   So, if `:effects` was:
 *    {:dispatch  [:hello 42]
 *     :db        {...}
 *     :undo      "set flag"}
 *   call the registered effects handlers for each of the map's keys:
 *   `:dispatch`, `:undo` and `:db`.
 */
re_frame.fx.do_fx = re_frame.interceptor.__GT_interceptor.call(null,new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"do-fx","do-fx",1194163050),new cljs.core.Keyword(null,"after","after",594996914),(function re_frame$fx$do_fx_after(context){
var seq__14860 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"effects","effects",-282369292).cljs$core$IFn$_invoke$arity$1(context));
var chunk__14861 = null;
var count__14862 = (0);
var i__14863 = (0);
while(true){
if((i__14863 < count__14862)){
var vec__14864 = cljs.core._nth.call(null,chunk__14861,i__14863);
var effect_k = cljs.core.nth.call(null,vec__14864,(0),null);
var value = cljs.core.nth.call(null,vec__14864,(1),null);
var temp__4655__auto___14870 = re_frame.registrar.get_handler.call(null,re_frame.fx.kind,effect_k,true);
if(cljs.core.truth_(temp__4655__auto___14870)){
var effect_fn_14871 = temp__4655__auto___14870;
effect_fn_14871.call(null,value);
} else {
}

var G__14872 = seq__14860;
var G__14873 = chunk__14861;
var G__14874 = count__14862;
var G__14875 = (i__14863 + (1));
seq__14860 = G__14872;
chunk__14861 = G__14873;
count__14862 = G__14874;
i__14863 = G__14875;
continue;
} else {
var temp__4657__auto__ = cljs.core.seq.call(null,seq__14860);
if(temp__4657__auto__){
var seq__14860__$1 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__14860__$1)){
var c__7220__auto__ = cljs.core.chunk_first.call(null,seq__14860__$1);
var G__14876 = cljs.core.chunk_rest.call(null,seq__14860__$1);
var G__14877 = c__7220__auto__;
var G__14878 = cljs.core.count.call(null,c__7220__auto__);
var G__14879 = (0);
seq__14860 = G__14876;
chunk__14861 = G__14877;
count__14862 = G__14878;
i__14863 = G__14879;
continue;
} else {
var vec__14867 = cljs.core.first.call(null,seq__14860__$1);
var effect_k = cljs.core.nth.call(null,vec__14867,(0),null);
var value = cljs.core.nth.call(null,vec__14867,(1),null);
var temp__4655__auto___14880 = re_frame.registrar.get_handler.call(null,re_frame.fx.kind,effect_k,true);
if(cljs.core.truth_(temp__4655__auto___14880)){
var effect_fn_14881 = temp__4655__auto___14880;
effect_fn_14881.call(null,value);
} else {
}

var G__14882 = cljs.core.next.call(null,seq__14860__$1);
var G__14883 = null;
var G__14884 = (0);
var G__14885 = (0);
seq__14860 = G__14882;
chunk__14861 = G__14883;
count__14862 = G__14884;
i__14863 = G__14885;
continue;
}
} else {
return null;
}
}
break;
}
}));
re_frame.fx.register.call(null,new cljs.core.Keyword(null,"dispatch-later","dispatch-later",291951390),(function (value){
var seq__14886 = cljs.core.seq.call(null,value);
var chunk__14887 = null;
var count__14888 = (0);
var i__14889 = (0);
while(true){
if((i__14889 < count__14888)){
var map__14890 = cljs.core._nth.call(null,chunk__14887,i__14889);
var map__14890__$1 = ((((!((map__14890 == null)))?((((map__14890.cljs$lang$protocol_mask$partition0$ & (64))) || (map__14890.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14890):map__14890);
var effect = map__14890__$1;
var ms = cljs.core.get.call(null,map__14890__$1,new cljs.core.Keyword(null,"ms","ms",-1152709733));
var dispatch = cljs.core.get.call(null,map__14890__$1,new cljs.core.Keyword(null,"dispatch","dispatch",1319337009));
if((cljs.core.empty_QMARK_.call(null,dispatch)) || (!(typeof ms === 'number'))){
re_frame.loggers.console.call(null,new cljs.core.Keyword(null,"error","error",-978969032),"re-frame: ignoring bad :dispatch-later value:",effect);
} else {
re_frame.interop.set_timeout_BANG_.call(null,((function (seq__14886,chunk__14887,count__14888,i__14889,map__14890,map__14890__$1,effect,ms,dispatch){
return (function (){
return re_frame.router.dispatch.call(null,dispatch);
});})(seq__14886,chunk__14887,count__14888,i__14889,map__14890,map__14890__$1,effect,ms,dispatch))
,ms);
}

var G__14894 = seq__14886;
var G__14895 = chunk__14887;
var G__14896 = count__14888;
var G__14897 = (i__14889 + (1));
seq__14886 = G__14894;
chunk__14887 = G__14895;
count__14888 = G__14896;
i__14889 = G__14897;
continue;
} else {
var temp__4657__auto__ = cljs.core.seq.call(null,seq__14886);
if(temp__4657__auto__){
var seq__14886__$1 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__14886__$1)){
var c__7220__auto__ = cljs.core.chunk_first.call(null,seq__14886__$1);
var G__14898 = cljs.core.chunk_rest.call(null,seq__14886__$1);
var G__14899 = c__7220__auto__;
var G__14900 = cljs.core.count.call(null,c__7220__auto__);
var G__14901 = (0);
seq__14886 = G__14898;
chunk__14887 = G__14899;
count__14888 = G__14900;
i__14889 = G__14901;
continue;
} else {
var map__14892 = cljs.core.first.call(null,seq__14886__$1);
var map__14892__$1 = ((((!((map__14892 == null)))?((((map__14892.cljs$lang$protocol_mask$partition0$ & (64))) || (map__14892.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14892):map__14892);
var effect = map__14892__$1;
var ms = cljs.core.get.call(null,map__14892__$1,new cljs.core.Keyword(null,"ms","ms",-1152709733));
var dispatch = cljs.core.get.call(null,map__14892__$1,new cljs.core.Keyword(null,"dispatch","dispatch",1319337009));
if((cljs.core.empty_QMARK_.call(null,dispatch)) || (!(typeof ms === 'number'))){
re_frame.loggers.console.call(null,new cljs.core.Keyword(null,"error","error",-978969032),"re-frame: ignoring bad :dispatch-later value:",effect);
} else {
re_frame.interop.set_timeout_BANG_.call(null,((function (seq__14886,chunk__14887,count__14888,i__14889,map__14892,map__14892__$1,effect,ms,dispatch,seq__14886__$1,temp__4657__auto__){
return (function (){
return re_frame.router.dispatch.call(null,dispatch);
});})(seq__14886,chunk__14887,count__14888,i__14889,map__14892,map__14892__$1,effect,ms,dispatch,seq__14886__$1,temp__4657__auto__))
,ms);
}

var G__14902 = cljs.core.next.call(null,seq__14886__$1);
var G__14903 = null;
var G__14904 = (0);
var G__14905 = (0);
seq__14886 = G__14902;
chunk__14887 = G__14903;
count__14888 = G__14904;
i__14889 = G__14905;
continue;
}
} else {
return null;
}
}
break;
}
}));
re_frame.fx.register.call(null,new cljs.core.Keyword(null,"dispatch","dispatch",1319337009),(function (value){
if(!(cljs.core.vector_QMARK_.call(null,value))){
return re_frame.loggers.console.call(null,new cljs.core.Keyword(null,"error","error",-978969032),"re-frame: ignoring bad :dispatch value. Expected a vector, but got:",value);
} else {
return re_frame.router.dispatch.call(null,value);
}
}));
re_frame.fx.register.call(null,new cljs.core.Keyword(null,"dispatch-n","dispatch-n",-504469236),(function (value){
if(!(cljs.core.sequential_QMARK_.call(null,value))){
re_frame.loggers.console.call(null,new cljs.core.Keyword(null,"error","error",-978969032),"re-frame: ignoring bad :dispatch-n value. Expected a collection, got got:",value);
} else {
}

var seq__14906 = cljs.core.seq.call(null,value);
var chunk__14907 = null;
var count__14908 = (0);
var i__14909 = (0);
while(true){
if((i__14909 < count__14908)){
var event = cljs.core._nth.call(null,chunk__14907,i__14909);
re_frame.router.dispatch.call(null,event);

var G__14910 = seq__14906;
var G__14911 = chunk__14907;
var G__14912 = count__14908;
var G__14913 = (i__14909 + (1));
seq__14906 = G__14910;
chunk__14907 = G__14911;
count__14908 = G__14912;
i__14909 = G__14913;
continue;
} else {
var temp__4657__auto__ = cljs.core.seq.call(null,seq__14906);
if(temp__4657__auto__){
var seq__14906__$1 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__14906__$1)){
var c__7220__auto__ = cljs.core.chunk_first.call(null,seq__14906__$1);
var G__14914 = cljs.core.chunk_rest.call(null,seq__14906__$1);
var G__14915 = c__7220__auto__;
var G__14916 = cljs.core.count.call(null,c__7220__auto__);
var G__14917 = (0);
seq__14906 = G__14914;
chunk__14907 = G__14915;
count__14908 = G__14916;
i__14909 = G__14917;
continue;
} else {
var event = cljs.core.first.call(null,seq__14906__$1);
re_frame.router.dispatch.call(null,event);

var G__14918 = cljs.core.next.call(null,seq__14906__$1);
var G__14919 = null;
var G__14920 = (0);
var G__14921 = (0);
seq__14906 = G__14918;
chunk__14907 = G__14919;
count__14908 = G__14920;
i__14909 = G__14921;
continue;
}
} else {
return null;
}
}
break;
}
}));
re_frame.fx.register.call(null,new cljs.core.Keyword(null,"deregister-event-handler","deregister-event-handler",-1096518994),(function (value){
var clear_event = cljs.core.partial.call(null,re_frame.registrar.clear_handlers,re_frame.events.kind);
if(cljs.core.sequential_QMARK_.call(null,value)){
var seq__14922 = cljs.core.seq.call(null,((cljs.core.sequential_QMARK_.call(null,value))?value:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [value], null)));
var chunk__14923 = null;
var count__14924 = (0);
var i__14925 = (0);
while(true){
if((i__14925 < count__14924)){
var event = cljs.core._nth.call(null,chunk__14923,i__14925);
clear_event.call(null,event);

var G__14926 = seq__14922;
var G__14927 = chunk__14923;
var G__14928 = count__14924;
var G__14929 = (i__14925 + (1));
seq__14922 = G__14926;
chunk__14923 = G__14927;
count__14924 = G__14928;
i__14925 = G__14929;
continue;
} else {
var temp__4657__auto__ = cljs.core.seq.call(null,seq__14922);
if(temp__4657__auto__){
var seq__14922__$1 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__14922__$1)){
var c__7220__auto__ = cljs.core.chunk_first.call(null,seq__14922__$1);
var G__14930 = cljs.core.chunk_rest.call(null,seq__14922__$1);
var G__14931 = c__7220__auto__;
var G__14932 = cljs.core.count.call(null,c__7220__auto__);
var G__14933 = (0);
seq__14922 = G__14930;
chunk__14923 = G__14931;
count__14924 = G__14932;
i__14925 = G__14933;
continue;
} else {
var event = cljs.core.first.call(null,seq__14922__$1);
clear_event.call(null,event);

var G__14934 = cljs.core.next.call(null,seq__14922__$1);
var G__14935 = null;
var G__14936 = (0);
var G__14937 = (0);
seq__14922 = G__14934;
chunk__14923 = G__14935;
count__14924 = G__14936;
i__14925 = G__14937;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return null;
}
}));
re_frame.fx.register.call(null,new cljs.core.Keyword(null,"db","db",993250759),(function (value){
return cljs.core.reset_BANG_.call(null,re_frame.db.app_db,value);
}));

//# sourceMappingURL=fx.js.map?rel=1499873950060