// Compiled by ClojureScript 1.9.229 {}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args10020 = [];
var len__7484__auto___10026 = arguments.length;
var i__7485__auto___10027 = (0);
while(true){
if((i__7485__auto___10027 < len__7484__auto___10026)){
args10020.push((arguments[i__7485__auto___10027]));

var G__10028 = (i__7485__auto___10027 + (1));
i__7485__auto___10027 = G__10028;
continue;
} else {
}
break;
}

var G__10022 = args10020.length;
switch (G__10022) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10020.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async10023 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async10023 = (function (f,blockable,meta10024){
this.f = f;
this.blockable = blockable;
this.meta10024 = meta10024;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_10025,meta10024__$1){
var self__ = this;
var _10025__$1 = this;
return (new cljs.core.async.t_cljs$core$async10023(self__.f,self__.blockable,meta10024__$1));
});

cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_10025){
var self__ = this;
var _10025__$1 = this;
return self__.meta10024;
});

cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async10023.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async10023.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta10024","meta10024",-2112665629,null)], null);
});

cljs.core.async.t_cljs$core$async10023.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async10023.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async10023";

cljs.core.async.t_cljs$core$async10023.cljs$lang$ctorPrWriter = (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async10023");
});

cljs.core.async.__GT_t_cljs$core$async10023 = (function cljs$core$async$__GT_t_cljs$core$async10023(f__$1,blockable__$1,meta10024){
return (new cljs.core.async.t_cljs$core$async10023(f__$1,blockable__$1,meta10024));
});

}

return (new cljs.core.async.t_cljs$core$async10023(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args10032 = [];
var len__7484__auto___10035 = arguments.length;
var i__7485__auto___10036 = (0);
while(true){
if((i__7485__auto___10036 < len__7484__auto___10035)){
args10032.push((arguments[i__7485__auto___10036]));

var G__10037 = (i__7485__auto___10036 + (1));
i__7485__auto___10036 = G__10037;
continue;
} else {
}
break;
}

var G__10034 = args10032.length;
switch (G__10034) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10032.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str("buf-or-n")].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args10039 = [];
var len__7484__auto___10042 = arguments.length;
var i__7485__auto___10043 = (0);
while(true){
if((i__7485__auto___10043 < len__7484__auto___10042)){
args10039.push((arguments[i__7485__auto___10043]));

var G__10044 = (i__7485__auto___10043 + (1));
i__7485__auto___10043 = G__10044;
continue;
} else {
}
break;
}

var G__10041 = args10039.length;
switch (G__10041) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10039.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args10046 = [];
var len__7484__auto___10049 = arguments.length;
var i__7485__auto___10050 = (0);
while(true){
if((i__7485__auto___10050 < len__7484__auto___10049)){
args10046.push((arguments[i__7485__auto___10050]));

var G__10051 = (i__7485__auto___10050 + (1));
i__7485__auto___10050 = G__10051;
continue;
} else {
}
break;
}

var G__10048 = args10046.length;
switch (G__10048) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10046.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_10053 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_10053);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_10053,ret){
return (function (){
return fn1.call(null,val_10053);
});})(val_10053,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args10054 = [];
var len__7484__auto___10057 = arguments.length;
var i__7485__auto___10058 = (0);
while(true){
if((i__7485__auto___10058 < len__7484__auto___10057)){
args10054.push((arguments[i__7485__auto___10058]));

var G__10059 = (i__7485__auto___10058 + (1));
i__7485__auto___10058 = G__10059;
continue;
} else {
}
break;
}

var G__10056 = args10054.length;
switch (G__10056) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10054.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4655__auto__)){
var ret = temp__4655__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4655__auto__)){
var retb = temp__4655__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4655__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4655__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__7324__auto___10061 = n;
var x_10062 = (0);
while(true){
if((x_10062 < n__7324__auto___10061)){
(a[x_10062] = (0));

var G__10063 = (x_10062 + (1));
x_10062 = G__10063;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__10064 = (i + (1));
i = G__10064;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async10068 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async10068 = (function (alt_flag,flag,meta10069){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta10069 = meta10069;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_10070,meta10069__$1){
var self__ = this;
var _10070__$1 = this;
return (new cljs.core.async.t_cljs$core$async10068(self__.alt_flag,self__.flag,meta10069__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_10070){
var self__ = this;
var _10070__$1 = this;
return self__.meta10069;
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-flag","alt-flag",-1794972754,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta10069","meta10069",-1155273364,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async10068.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async10068.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async10068";

cljs.core.async.t_cljs$core$async10068.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async10068");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async10068 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async10068(alt_flag__$1,flag__$1,meta10069){
return (new cljs.core.async.t_cljs$core$async10068(alt_flag__$1,flag__$1,meta10069));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async10068(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async10074 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async10074 = (function (alt_handler,flag,cb,meta10075){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta10075 = meta10075;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_10076,meta10075__$1){
var self__ = this;
var _10076__$1 = this;
return (new cljs.core.async.t_cljs$core$async10074(self__.alt_handler,self__.flag,self__.cb,meta10075__$1));
});

cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_10076){
var self__ = this;
var _10076__$1 = this;
return self__.meta10075;
});

cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async10074.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async10074.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-handler","alt-handler",963786170,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null)], null)))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta10075","meta10075",-504005034,null)], null);
});

cljs.core.async.t_cljs$core$async10074.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async10074.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async10074";

cljs.core.async.t_cljs$core$async10074.cljs$lang$ctorPrWriter = (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async10074");
});

cljs.core.async.__GT_t_cljs$core$async10074 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async10074(alt_handler__$1,flag__$1,cb__$1,meta10075){
return (new cljs.core.async.t_cljs$core$async10074(alt_handler__$1,flag__$1,cb__$1,meta10075));
});

}

return (new cljs.core.async.t_cljs$core$async10074(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__10077_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__10077_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__10078_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__10078_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__6409__auto__ = wport;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return port;
}
})()], null));
} else {
var G__10079 = (i + (1));
i = G__10079;
continue;
}
} else {
return null;
}
break;
}
})();
var or__6409__auto__ = ret;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4657__auto__ = (function (){var and__6397__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__6397__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__6397__auto__;
}
})();
if(cljs.core.truth_(temp__4657__auto__)){
var got = temp__4657__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__7491__auto__ = [];
var len__7484__auto___10085 = arguments.length;
var i__7485__auto___10086 = (0);
while(true){
if((i__7485__auto___10086 < len__7484__auto___10085)){
args__7491__auto__.push((arguments[i__7485__auto___10086]));

var G__10087 = (i__7485__auto___10086 + (1));
i__7485__auto___10086 = G__10087;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__10082){
var map__10083 = p__10082;
var map__10083__$1 = ((((!((map__10083 == null)))?((((map__10083.cljs$lang$protocol_mask$partition0$ & (64))) || (map__10083.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10083):map__10083);
var opts = map__10083__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq10080){
var G__10081 = cljs.core.first.call(null,seq10080);
var seq10080__$1 = cljs.core.next.call(null,seq10080);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__10081,seq10080__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args10088 = [];
var len__7484__auto___10138 = arguments.length;
var i__7485__auto___10139 = (0);
while(true){
if((i__7485__auto___10139 < len__7484__auto___10138)){
args10088.push((arguments[i__7485__auto___10139]));

var G__10140 = (i__7485__auto___10139 + (1));
i__7485__auto___10139 = G__10140;
continue;
} else {
}
break;
}

var G__10090 = args10088.length;
switch (G__10090) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10088.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__9975__auto___10142 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___10142){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___10142){
return (function (state_10114){
var state_val_10115 = (state_10114[(1)]);
if((state_val_10115 === (7))){
var inst_10110 = (state_10114[(2)]);
var state_10114__$1 = state_10114;
var statearr_10116_10143 = state_10114__$1;
(statearr_10116_10143[(2)] = inst_10110);

(statearr_10116_10143[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (1))){
var state_10114__$1 = state_10114;
var statearr_10117_10144 = state_10114__$1;
(statearr_10117_10144[(2)] = null);

(statearr_10117_10144[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (4))){
var inst_10093 = (state_10114[(7)]);
var inst_10093__$1 = (state_10114[(2)]);
var inst_10094 = (inst_10093__$1 == null);
var state_10114__$1 = (function (){var statearr_10118 = state_10114;
(statearr_10118[(7)] = inst_10093__$1);

return statearr_10118;
})();
if(cljs.core.truth_(inst_10094)){
var statearr_10119_10145 = state_10114__$1;
(statearr_10119_10145[(1)] = (5));

} else {
var statearr_10120_10146 = state_10114__$1;
(statearr_10120_10146[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (13))){
var state_10114__$1 = state_10114;
var statearr_10121_10147 = state_10114__$1;
(statearr_10121_10147[(2)] = null);

(statearr_10121_10147[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (6))){
var inst_10093 = (state_10114[(7)]);
var state_10114__$1 = state_10114;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10114__$1,(11),to,inst_10093);
} else {
if((state_val_10115 === (3))){
var inst_10112 = (state_10114[(2)]);
var state_10114__$1 = state_10114;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10114__$1,inst_10112);
} else {
if((state_val_10115 === (12))){
var state_10114__$1 = state_10114;
var statearr_10122_10148 = state_10114__$1;
(statearr_10122_10148[(2)] = null);

(statearr_10122_10148[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (2))){
var state_10114__$1 = state_10114;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10114__$1,(4),from);
} else {
if((state_val_10115 === (11))){
var inst_10103 = (state_10114[(2)]);
var state_10114__$1 = state_10114;
if(cljs.core.truth_(inst_10103)){
var statearr_10123_10149 = state_10114__$1;
(statearr_10123_10149[(1)] = (12));

} else {
var statearr_10124_10150 = state_10114__$1;
(statearr_10124_10150[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (9))){
var state_10114__$1 = state_10114;
var statearr_10125_10151 = state_10114__$1;
(statearr_10125_10151[(2)] = null);

(statearr_10125_10151[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (5))){
var state_10114__$1 = state_10114;
if(cljs.core.truth_(close_QMARK_)){
var statearr_10126_10152 = state_10114__$1;
(statearr_10126_10152[(1)] = (8));

} else {
var statearr_10127_10153 = state_10114__$1;
(statearr_10127_10153[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (14))){
var inst_10108 = (state_10114[(2)]);
var state_10114__$1 = state_10114;
var statearr_10128_10154 = state_10114__$1;
(statearr_10128_10154[(2)] = inst_10108);

(statearr_10128_10154[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (10))){
var inst_10100 = (state_10114[(2)]);
var state_10114__$1 = state_10114;
var statearr_10129_10155 = state_10114__$1;
(statearr_10129_10155[(2)] = inst_10100);

(statearr_10129_10155[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10115 === (8))){
var inst_10097 = cljs.core.async.close_BANG_.call(null,to);
var state_10114__$1 = state_10114;
var statearr_10130_10156 = state_10114__$1;
(statearr_10130_10156[(2)] = inst_10097);

(statearr_10130_10156[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___10142))
;
return ((function (switch__8768__auto__,c__9975__auto___10142){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_10134 = [null,null,null,null,null,null,null,null];
(statearr_10134[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_10134[(1)] = (1));

return statearr_10134;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_10114){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10114);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10135){if((e10135 instanceof Object)){
var ex__8772__auto__ = e10135;
var statearr_10136_10157 = state_10114;
(statearr_10136_10157[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10114);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10135;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10158 = state_10114;
state_10114 = G__10158;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_10114){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_10114);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___10142))
})();
var state__9977__auto__ = (function (){var statearr_10137 = f__9976__auto__.call(null);
(statearr_10137[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10142);

return statearr_10137;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___10142))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__10346){
var vec__10347 = p__10346;
var v = cljs.core.nth.call(null,vec__10347,(0),null);
var p = cljs.core.nth.call(null,vec__10347,(1),null);
var job = vec__10347;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__9975__auto___10533 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results){
return (function (state_10354){
var state_val_10355 = (state_10354[(1)]);
if((state_val_10355 === (1))){
var state_10354__$1 = state_10354;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10354__$1,(2),res,v);
} else {
if((state_val_10355 === (2))){
var inst_10351 = (state_10354[(2)]);
var inst_10352 = cljs.core.async.close_BANG_.call(null,res);
var state_10354__$1 = (function (){var statearr_10356 = state_10354;
(statearr_10356[(7)] = inst_10351);

return statearr_10356;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10354__$1,inst_10352);
} else {
return null;
}
}
});})(c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results))
;
return ((function (switch__8768__auto__,c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_10360 = [null,null,null,null,null,null,null,null];
(statearr_10360[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__);

(statearr_10360[(1)] = (1));

return statearr_10360;
});
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1 = (function (state_10354){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10354);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10361){if((e10361 instanceof Object)){
var ex__8772__auto__ = e10361;
var statearr_10362_10534 = state_10354;
(statearr_10362_10534[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10354);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10361;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10535 = state_10354;
state_10354 = G__10535;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = function(state_10354){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1.call(this,state_10354);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results))
})();
var state__9977__auto__ = (function (){var statearr_10363 = f__9976__auto__.call(null);
(statearr_10363[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10533);

return statearr_10363;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___10533,res,vec__10347,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__10364){
var vec__10365 = p__10364;
var v = cljs.core.nth.call(null,vec__10365,(0),null);
var p = cljs.core.nth.call(null,vec__10365,(1),null);
var job = vec__10365;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__7324__auto___10536 = n;
var __10537 = (0);
while(true){
if((__10537 < n__7324__auto___10536)){
var G__10368_10538 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__10368_10538) {
case "compute":
var c__9975__auto___10540 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__10537,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (__10537,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function (state_10381){
var state_val_10382 = (state_10381[(1)]);
if((state_val_10382 === (1))){
var state_10381__$1 = state_10381;
var statearr_10383_10541 = state_10381__$1;
(statearr_10383_10541[(2)] = null);

(statearr_10383_10541[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10382 === (2))){
var state_10381__$1 = state_10381;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10381__$1,(4),jobs);
} else {
if((state_val_10382 === (3))){
var inst_10379 = (state_10381[(2)]);
var state_10381__$1 = state_10381;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10381__$1,inst_10379);
} else {
if((state_val_10382 === (4))){
var inst_10371 = (state_10381[(2)]);
var inst_10372 = process.call(null,inst_10371);
var state_10381__$1 = state_10381;
if(cljs.core.truth_(inst_10372)){
var statearr_10384_10542 = state_10381__$1;
(statearr_10384_10542[(1)] = (5));

} else {
var statearr_10385_10543 = state_10381__$1;
(statearr_10385_10543[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10382 === (5))){
var state_10381__$1 = state_10381;
var statearr_10386_10544 = state_10381__$1;
(statearr_10386_10544[(2)] = null);

(statearr_10386_10544[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10382 === (6))){
var state_10381__$1 = state_10381;
var statearr_10387_10545 = state_10381__$1;
(statearr_10387_10545[(2)] = null);

(statearr_10387_10545[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10382 === (7))){
var inst_10377 = (state_10381[(2)]);
var state_10381__$1 = state_10381;
var statearr_10388_10546 = state_10381__$1;
(statearr_10388_10546[(2)] = inst_10377);

(statearr_10388_10546[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__10537,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
;
return ((function (__10537,switch__8768__auto__,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_10392 = [null,null,null,null,null,null,null];
(statearr_10392[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__);

(statearr_10392[(1)] = (1));

return statearr_10392;
});
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1 = (function (state_10381){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10381);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10393){if((e10393 instanceof Object)){
var ex__8772__auto__ = e10393;
var statearr_10394_10547 = state_10381;
(statearr_10394_10547[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10381);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10393;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10548 = state_10381;
state_10381 = G__10548;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = function(state_10381){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1.call(this,state_10381);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__;
})()
;})(__10537,switch__8768__auto__,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
})();
var state__9977__auto__ = (function (){var statearr_10395 = f__9976__auto__.call(null);
(statearr_10395[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10540);

return statearr_10395;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(__10537,c__9975__auto___10540,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
);


break;
case "async":
var c__9975__auto___10549 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__10537,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (__10537,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function (state_10408){
var state_val_10409 = (state_10408[(1)]);
if((state_val_10409 === (1))){
var state_10408__$1 = state_10408;
var statearr_10410_10550 = state_10408__$1;
(statearr_10410_10550[(2)] = null);

(statearr_10410_10550[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10409 === (2))){
var state_10408__$1 = state_10408;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10408__$1,(4),jobs);
} else {
if((state_val_10409 === (3))){
var inst_10406 = (state_10408[(2)]);
var state_10408__$1 = state_10408;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10408__$1,inst_10406);
} else {
if((state_val_10409 === (4))){
var inst_10398 = (state_10408[(2)]);
var inst_10399 = async.call(null,inst_10398);
var state_10408__$1 = state_10408;
if(cljs.core.truth_(inst_10399)){
var statearr_10411_10551 = state_10408__$1;
(statearr_10411_10551[(1)] = (5));

} else {
var statearr_10412_10552 = state_10408__$1;
(statearr_10412_10552[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10409 === (5))){
var state_10408__$1 = state_10408;
var statearr_10413_10553 = state_10408__$1;
(statearr_10413_10553[(2)] = null);

(statearr_10413_10553[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10409 === (6))){
var state_10408__$1 = state_10408;
var statearr_10414_10554 = state_10408__$1;
(statearr_10414_10554[(2)] = null);

(statearr_10414_10554[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10409 === (7))){
var inst_10404 = (state_10408[(2)]);
var state_10408__$1 = state_10408;
var statearr_10415_10555 = state_10408__$1;
(statearr_10415_10555[(2)] = inst_10404);

(statearr_10415_10555[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__10537,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
;
return ((function (__10537,switch__8768__auto__,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_10419 = [null,null,null,null,null,null,null];
(statearr_10419[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__);

(statearr_10419[(1)] = (1));

return statearr_10419;
});
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1 = (function (state_10408){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10408);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10420){if((e10420 instanceof Object)){
var ex__8772__auto__ = e10420;
var statearr_10421_10556 = state_10408;
(statearr_10421_10556[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10408);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10420;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10557 = state_10408;
state_10408 = G__10557;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = function(state_10408){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1.call(this,state_10408);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__;
})()
;})(__10537,switch__8768__auto__,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
})();
var state__9977__auto__ = (function (){var statearr_10422 = f__9976__auto__.call(null);
(statearr_10422[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10549);

return statearr_10422;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(__10537,c__9975__auto___10549,G__10368_10538,n__7324__auto___10536,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__10558 = (__10537 + (1));
__10537 = G__10558;
continue;
} else {
}
break;
}

var c__9975__auto___10559 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___10559,jobs,results,process,async){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___10559,jobs,results,process,async){
return (function (state_10444){
var state_val_10445 = (state_10444[(1)]);
if((state_val_10445 === (1))){
var state_10444__$1 = state_10444;
var statearr_10446_10560 = state_10444__$1;
(statearr_10446_10560[(2)] = null);

(statearr_10446_10560[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10445 === (2))){
var state_10444__$1 = state_10444;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10444__$1,(4),from);
} else {
if((state_val_10445 === (3))){
var inst_10442 = (state_10444[(2)]);
var state_10444__$1 = state_10444;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10444__$1,inst_10442);
} else {
if((state_val_10445 === (4))){
var inst_10425 = (state_10444[(7)]);
var inst_10425__$1 = (state_10444[(2)]);
var inst_10426 = (inst_10425__$1 == null);
var state_10444__$1 = (function (){var statearr_10447 = state_10444;
(statearr_10447[(7)] = inst_10425__$1);

return statearr_10447;
})();
if(cljs.core.truth_(inst_10426)){
var statearr_10448_10561 = state_10444__$1;
(statearr_10448_10561[(1)] = (5));

} else {
var statearr_10449_10562 = state_10444__$1;
(statearr_10449_10562[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10445 === (5))){
var inst_10428 = cljs.core.async.close_BANG_.call(null,jobs);
var state_10444__$1 = state_10444;
var statearr_10450_10563 = state_10444__$1;
(statearr_10450_10563[(2)] = inst_10428);

(statearr_10450_10563[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10445 === (6))){
var inst_10425 = (state_10444[(7)]);
var inst_10430 = (state_10444[(8)]);
var inst_10430__$1 = cljs.core.async.chan.call(null,(1));
var inst_10431 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_10432 = [inst_10425,inst_10430__$1];
var inst_10433 = (new cljs.core.PersistentVector(null,2,(5),inst_10431,inst_10432,null));
var state_10444__$1 = (function (){var statearr_10451 = state_10444;
(statearr_10451[(8)] = inst_10430__$1);

return statearr_10451;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10444__$1,(8),jobs,inst_10433);
} else {
if((state_val_10445 === (7))){
var inst_10440 = (state_10444[(2)]);
var state_10444__$1 = state_10444;
var statearr_10452_10564 = state_10444__$1;
(statearr_10452_10564[(2)] = inst_10440);

(statearr_10452_10564[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10445 === (8))){
var inst_10430 = (state_10444[(8)]);
var inst_10435 = (state_10444[(2)]);
var state_10444__$1 = (function (){var statearr_10453 = state_10444;
(statearr_10453[(9)] = inst_10435);

return statearr_10453;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10444__$1,(9),results,inst_10430);
} else {
if((state_val_10445 === (9))){
var inst_10437 = (state_10444[(2)]);
var state_10444__$1 = (function (){var statearr_10454 = state_10444;
(statearr_10454[(10)] = inst_10437);

return statearr_10454;
})();
var statearr_10455_10565 = state_10444__$1;
(statearr_10455_10565[(2)] = null);

(statearr_10455_10565[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___10559,jobs,results,process,async))
;
return ((function (switch__8768__auto__,c__9975__auto___10559,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_10459 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_10459[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__);

(statearr_10459[(1)] = (1));

return statearr_10459;
});
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1 = (function (state_10444){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10444);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10460){if((e10460 instanceof Object)){
var ex__8772__auto__ = e10460;
var statearr_10461_10566 = state_10444;
(statearr_10461_10566[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10444);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10460;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10567 = state_10444;
state_10444 = G__10567;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = function(state_10444){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1.call(this,state_10444);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___10559,jobs,results,process,async))
})();
var state__9977__auto__ = (function (){var statearr_10462 = f__9976__auto__.call(null);
(statearr_10462[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10559);

return statearr_10462;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___10559,jobs,results,process,async))
);


var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__,jobs,results,process,async){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__,jobs,results,process,async){
return (function (state_10500){
var state_val_10501 = (state_10500[(1)]);
if((state_val_10501 === (7))){
var inst_10496 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
var statearr_10502_10568 = state_10500__$1;
(statearr_10502_10568[(2)] = inst_10496);

(statearr_10502_10568[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (20))){
var state_10500__$1 = state_10500;
var statearr_10503_10569 = state_10500__$1;
(statearr_10503_10569[(2)] = null);

(statearr_10503_10569[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (1))){
var state_10500__$1 = state_10500;
var statearr_10504_10570 = state_10500__$1;
(statearr_10504_10570[(2)] = null);

(statearr_10504_10570[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (4))){
var inst_10465 = (state_10500[(7)]);
var inst_10465__$1 = (state_10500[(2)]);
var inst_10466 = (inst_10465__$1 == null);
var state_10500__$1 = (function (){var statearr_10505 = state_10500;
(statearr_10505[(7)] = inst_10465__$1);

return statearr_10505;
})();
if(cljs.core.truth_(inst_10466)){
var statearr_10506_10571 = state_10500__$1;
(statearr_10506_10571[(1)] = (5));

} else {
var statearr_10507_10572 = state_10500__$1;
(statearr_10507_10572[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (15))){
var inst_10478 = (state_10500[(8)]);
var state_10500__$1 = state_10500;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10500__$1,(18),to,inst_10478);
} else {
if((state_val_10501 === (21))){
var inst_10491 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
var statearr_10508_10573 = state_10500__$1;
(statearr_10508_10573[(2)] = inst_10491);

(statearr_10508_10573[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (13))){
var inst_10493 = (state_10500[(2)]);
var state_10500__$1 = (function (){var statearr_10509 = state_10500;
(statearr_10509[(9)] = inst_10493);

return statearr_10509;
})();
var statearr_10510_10574 = state_10500__$1;
(statearr_10510_10574[(2)] = null);

(statearr_10510_10574[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (6))){
var inst_10465 = (state_10500[(7)]);
var state_10500__$1 = state_10500;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10500__$1,(11),inst_10465);
} else {
if((state_val_10501 === (17))){
var inst_10486 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
if(cljs.core.truth_(inst_10486)){
var statearr_10511_10575 = state_10500__$1;
(statearr_10511_10575[(1)] = (19));

} else {
var statearr_10512_10576 = state_10500__$1;
(statearr_10512_10576[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (3))){
var inst_10498 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10500__$1,inst_10498);
} else {
if((state_val_10501 === (12))){
var inst_10475 = (state_10500[(10)]);
var state_10500__$1 = state_10500;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10500__$1,(14),inst_10475);
} else {
if((state_val_10501 === (2))){
var state_10500__$1 = state_10500;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10500__$1,(4),results);
} else {
if((state_val_10501 === (19))){
var state_10500__$1 = state_10500;
var statearr_10513_10577 = state_10500__$1;
(statearr_10513_10577[(2)] = null);

(statearr_10513_10577[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (11))){
var inst_10475 = (state_10500[(2)]);
var state_10500__$1 = (function (){var statearr_10514 = state_10500;
(statearr_10514[(10)] = inst_10475);

return statearr_10514;
})();
var statearr_10515_10578 = state_10500__$1;
(statearr_10515_10578[(2)] = null);

(statearr_10515_10578[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (9))){
var state_10500__$1 = state_10500;
var statearr_10516_10579 = state_10500__$1;
(statearr_10516_10579[(2)] = null);

(statearr_10516_10579[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (5))){
var state_10500__$1 = state_10500;
if(cljs.core.truth_(close_QMARK_)){
var statearr_10517_10580 = state_10500__$1;
(statearr_10517_10580[(1)] = (8));

} else {
var statearr_10518_10581 = state_10500__$1;
(statearr_10518_10581[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (14))){
var inst_10480 = (state_10500[(11)]);
var inst_10478 = (state_10500[(8)]);
var inst_10478__$1 = (state_10500[(2)]);
var inst_10479 = (inst_10478__$1 == null);
var inst_10480__$1 = cljs.core.not.call(null,inst_10479);
var state_10500__$1 = (function (){var statearr_10519 = state_10500;
(statearr_10519[(11)] = inst_10480__$1);

(statearr_10519[(8)] = inst_10478__$1);

return statearr_10519;
})();
if(inst_10480__$1){
var statearr_10520_10582 = state_10500__$1;
(statearr_10520_10582[(1)] = (15));

} else {
var statearr_10521_10583 = state_10500__$1;
(statearr_10521_10583[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (16))){
var inst_10480 = (state_10500[(11)]);
var state_10500__$1 = state_10500;
var statearr_10522_10584 = state_10500__$1;
(statearr_10522_10584[(2)] = inst_10480);

(statearr_10522_10584[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (10))){
var inst_10472 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
var statearr_10523_10585 = state_10500__$1;
(statearr_10523_10585[(2)] = inst_10472);

(statearr_10523_10585[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (18))){
var inst_10483 = (state_10500[(2)]);
var state_10500__$1 = state_10500;
var statearr_10524_10586 = state_10500__$1;
(statearr_10524_10586[(2)] = inst_10483);

(statearr_10524_10586[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10501 === (8))){
var inst_10469 = cljs.core.async.close_BANG_.call(null,to);
var state_10500__$1 = state_10500;
var statearr_10525_10587 = state_10500__$1;
(statearr_10525_10587[(2)] = inst_10469);

(statearr_10525_10587[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto__,jobs,results,process,async))
;
return ((function (switch__8768__auto__,c__9975__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_10529 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_10529[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__);

(statearr_10529[(1)] = (1));

return statearr_10529;
});
var cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1 = (function (state_10500){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10500);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10530){if((e10530 instanceof Object)){
var ex__8772__auto__ = e10530;
var statearr_10531_10588 = state_10500;
(statearr_10531_10588[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10500);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10530;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10589 = state_10500;
state_10500 = G__10589;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__ = function(state_10500){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1.call(this,state_10500);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__,jobs,results,process,async))
})();
var state__9977__auto__ = (function (){var statearr_10532 = f__9976__auto__.call(null);
(statearr_10532[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_10532;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__,jobs,results,process,async))
);

return c__9975__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args10590 = [];
var len__7484__auto___10593 = arguments.length;
var i__7485__auto___10594 = (0);
while(true){
if((i__7485__auto___10594 < len__7484__auto___10593)){
args10590.push((arguments[i__7485__auto___10594]));

var G__10595 = (i__7485__auto___10594 + (1));
i__7485__auto___10594 = G__10595;
continue;
} else {
}
break;
}

var G__10592 = args10590.length;
switch (G__10592) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10590.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args10597 = [];
var len__7484__auto___10600 = arguments.length;
var i__7485__auto___10601 = (0);
while(true){
if((i__7485__auto___10601 < len__7484__auto___10600)){
args10597.push((arguments[i__7485__auto___10601]));

var G__10602 = (i__7485__auto___10601 + (1));
i__7485__auto___10601 = G__10602;
continue;
} else {
}
break;
}

var G__10599 = args10597.length;
switch (G__10599) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10597.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args10604 = [];
var len__7484__auto___10657 = arguments.length;
var i__7485__auto___10658 = (0);
while(true){
if((i__7485__auto___10658 < len__7484__auto___10657)){
args10604.push((arguments[i__7485__auto___10658]));

var G__10659 = (i__7485__auto___10658 + (1));
i__7485__auto___10658 = G__10659;
continue;
} else {
}
break;
}

var G__10606 = args10604.length;
switch (G__10606) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10604.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__9975__auto___10661 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___10661,tc,fc){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___10661,tc,fc){
return (function (state_10632){
var state_val_10633 = (state_10632[(1)]);
if((state_val_10633 === (7))){
var inst_10628 = (state_10632[(2)]);
var state_10632__$1 = state_10632;
var statearr_10634_10662 = state_10632__$1;
(statearr_10634_10662[(2)] = inst_10628);

(statearr_10634_10662[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (1))){
var state_10632__$1 = state_10632;
var statearr_10635_10663 = state_10632__$1;
(statearr_10635_10663[(2)] = null);

(statearr_10635_10663[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (4))){
var inst_10609 = (state_10632[(7)]);
var inst_10609__$1 = (state_10632[(2)]);
var inst_10610 = (inst_10609__$1 == null);
var state_10632__$1 = (function (){var statearr_10636 = state_10632;
(statearr_10636[(7)] = inst_10609__$1);

return statearr_10636;
})();
if(cljs.core.truth_(inst_10610)){
var statearr_10637_10664 = state_10632__$1;
(statearr_10637_10664[(1)] = (5));

} else {
var statearr_10638_10665 = state_10632__$1;
(statearr_10638_10665[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (13))){
var state_10632__$1 = state_10632;
var statearr_10639_10666 = state_10632__$1;
(statearr_10639_10666[(2)] = null);

(statearr_10639_10666[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (6))){
var inst_10609 = (state_10632[(7)]);
var inst_10615 = p.call(null,inst_10609);
var state_10632__$1 = state_10632;
if(cljs.core.truth_(inst_10615)){
var statearr_10640_10667 = state_10632__$1;
(statearr_10640_10667[(1)] = (9));

} else {
var statearr_10641_10668 = state_10632__$1;
(statearr_10641_10668[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (3))){
var inst_10630 = (state_10632[(2)]);
var state_10632__$1 = state_10632;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10632__$1,inst_10630);
} else {
if((state_val_10633 === (12))){
var state_10632__$1 = state_10632;
var statearr_10642_10669 = state_10632__$1;
(statearr_10642_10669[(2)] = null);

(statearr_10642_10669[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (2))){
var state_10632__$1 = state_10632;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10632__$1,(4),ch);
} else {
if((state_val_10633 === (11))){
var inst_10609 = (state_10632[(7)]);
var inst_10619 = (state_10632[(2)]);
var state_10632__$1 = state_10632;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10632__$1,(8),inst_10619,inst_10609);
} else {
if((state_val_10633 === (9))){
var state_10632__$1 = state_10632;
var statearr_10643_10670 = state_10632__$1;
(statearr_10643_10670[(2)] = tc);

(statearr_10643_10670[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (5))){
var inst_10612 = cljs.core.async.close_BANG_.call(null,tc);
var inst_10613 = cljs.core.async.close_BANG_.call(null,fc);
var state_10632__$1 = (function (){var statearr_10644 = state_10632;
(statearr_10644[(8)] = inst_10612);

return statearr_10644;
})();
var statearr_10645_10671 = state_10632__$1;
(statearr_10645_10671[(2)] = inst_10613);

(statearr_10645_10671[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (14))){
var inst_10626 = (state_10632[(2)]);
var state_10632__$1 = state_10632;
var statearr_10646_10672 = state_10632__$1;
(statearr_10646_10672[(2)] = inst_10626);

(statearr_10646_10672[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (10))){
var state_10632__$1 = state_10632;
var statearr_10647_10673 = state_10632__$1;
(statearr_10647_10673[(2)] = fc);

(statearr_10647_10673[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10633 === (8))){
var inst_10621 = (state_10632[(2)]);
var state_10632__$1 = state_10632;
if(cljs.core.truth_(inst_10621)){
var statearr_10648_10674 = state_10632__$1;
(statearr_10648_10674[(1)] = (12));

} else {
var statearr_10649_10675 = state_10632__$1;
(statearr_10649_10675[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___10661,tc,fc))
;
return ((function (switch__8768__auto__,c__9975__auto___10661,tc,fc){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_10653 = [null,null,null,null,null,null,null,null,null];
(statearr_10653[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_10653[(1)] = (1));

return statearr_10653;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_10632){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10632);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10654){if((e10654 instanceof Object)){
var ex__8772__auto__ = e10654;
var statearr_10655_10676 = state_10632;
(statearr_10655_10676[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10632);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10654;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10677 = state_10632;
state_10632 = G__10677;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_10632){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_10632);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___10661,tc,fc))
})();
var state__9977__auto__ = (function (){var statearr_10656 = f__9976__auto__.call(null);
(statearr_10656[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___10661);

return statearr_10656;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___10661,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__){
return (function (state_10741){
var state_val_10742 = (state_10741[(1)]);
if((state_val_10742 === (7))){
var inst_10737 = (state_10741[(2)]);
var state_10741__$1 = state_10741;
var statearr_10743_10764 = state_10741__$1;
(statearr_10743_10764[(2)] = inst_10737);

(statearr_10743_10764[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (1))){
var inst_10721 = init;
var state_10741__$1 = (function (){var statearr_10744 = state_10741;
(statearr_10744[(7)] = inst_10721);

return statearr_10744;
})();
var statearr_10745_10765 = state_10741__$1;
(statearr_10745_10765[(2)] = null);

(statearr_10745_10765[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (4))){
var inst_10724 = (state_10741[(8)]);
var inst_10724__$1 = (state_10741[(2)]);
var inst_10725 = (inst_10724__$1 == null);
var state_10741__$1 = (function (){var statearr_10746 = state_10741;
(statearr_10746[(8)] = inst_10724__$1);

return statearr_10746;
})();
if(cljs.core.truth_(inst_10725)){
var statearr_10747_10766 = state_10741__$1;
(statearr_10747_10766[(1)] = (5));

} else {
var statearr_10748_10767 = state_10741__$1;
(statearr_10748_10767[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (6))){
var inst_10724 = (state_10741[(8)]);
var inst_10728 = (state_10741[(9)]);
var inst_10721 = (state_10741[(7)]);
var inst_10728__$1 = f.call(null,inst_10721,inst_10724);
var inst_10729 = cljs.core.reduced_QMARK_.call(null,inst_10728__$1);
var state_10741__$1 = (function (){var statearr_10749 = state_10741;
(statearr_10749[(9)] = inst_10728__$1);

return statearr_10749;
})();
if(inst_10729){
var statearr_10750_10768 = state_10741__$1;
(statearr_10750_10768[(1)] = (8));

} else {
var statearr_10751_10769 = state_10741__$1;
(statearr_10751_10769[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (3))){
var inst_10739 = (state_10741[(2)]);
var state_10741__$1 = state_10741;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10741__$1,inst_10739);
} else {
if((state_val_10742 === (2))){
var state_10741__$1 = state_10741;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10741__$1,(4),ch);
} else {
if((state_val_10742 === (9))){
var inst_10728 = (state_10741[(9)]);
var inst_10721 = inst_10728;
var state_10741__$1 = (function (){var statearr_10752 = state_10741;
(statearr_10752[(7)] = inst_10721);

return statearr_10752;
})();
var statearr_10753_10770 = state_10741__$1;
(statearr_10753_10770[(2)] = null);

(statearr_10753_10770[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (5))){
var inst_10721 = (state_10741[(7)]);
var state_10741__$1 = state_10741;
var statearr_10754_10771 = state_10741__$1;
(statearr_10754_10771[(2)] = inst_10721);

(statearr_10754_10771[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (10))){
var inst_10735 = (state_10741[(2)]);
var state_10741__$1 = state_10741;
var statearr_10755_10772 = state_10741__$1;
(statearr_10755_10772[(2)] = inst_10735);

(statearr_10755_10772[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10742 === (8))){
var inst_10728 = (state_10741[(9)]);
var inst_10731 = cljs.core.deref.call(null,inst_10728);
var state_10741__$1 = state_10741;
var statearr_10756_10773 = state_10741__$1;
(statearr_10756_10773[(2)] = inst_10731);

(statearr_10756_10773[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto__))
;
return ((function (switch__8768__auto__,c__9975__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__8769__auto__ = null;
var cljs$core$async$reduce_$_state_machine__8769__auto____0 = (function (){
var statearr_10760 = [null,null,null,null,null,null,null,null,null,null];
(statearr_10760[(0)] = cljs$core$async$reduce_$_state_machine__8769__auto__);

(statearr_10760[(1)] = (1));

return statearr_10760;
});
var cljs$core$async$reduce_$_state_machine__8769__auto____1 = (function (state_10741){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10741);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10761){if((e10761 instanceof Object)){
var ex__8772__auto__ = e10761;
var statearr_10762_10774 = state_10741;
(statearr_10762_10774[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10741);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10761;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10775 = state_10741;
state_10741 = G__10775;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__8769__auto__ = function(state_10741){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__8769__auto____1.call(this,state_10741);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__8769__auto____0;
cljs$core$async$reduce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__8769__auto____1;
return cljs$core$async$reduce_$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__))
})();
var state__9977__auto__ = (function (){var statearr_10763 = f__9976__auto__.call(null);
(statearr_10763[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_10763;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__))
);

return c__9975__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__,f__$1){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__,f__$1){
return (function (state_10795){
var state_val_10796 = (state_10795[(1)]);
if((state_val_10796 === (1))){
var inst_10790 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_10795__$1 = state_10795;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10795__$1,(2),inst_10790);
} else {
if((state_val_10796 === (2))){
var inst_10792 = (state_10795[(2)]);
var inst_10793 = f__$1.call(null,inst_10792);
var state_10795__$1 = state_10795;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10795__$1,inst_10793);
} else {
return null;
}
}
});})(c__9975__auto__,f__$1))
;
return ((function (switch__8768__auto__,c__9975__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__8769__auto__ = null;
var cljs$core$async$transduce_$_state_machine__8769__auto____0 = (function (){
var statearr_10800 = [null,null,null,null,null,null,null];
(statearr_10800[(0)] = cljs$core$async$transduce_$_state_machine__8769__auto__);

(statearr_10800[(1)] = (1));

return statearr_10800;
});
var cljs$core$async$transduce_$_state_machine__8769__auto____1 = (function (state_10795){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10795);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10801){if((e10801 instanceof Object)){
var ex__8772__auto__ = e10801;
var statearr_10802_10804 = state_10795;
(statearr_10802_10804[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10795);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10801;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10805 = state_10795;
state_10795 = G__10805;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__8769__auto__ = function(state_10795){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__8769__auto____1.call(this,state_10795);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__8769__auto____0;
cljs$core$async$transduce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__8769__auto____1;
return cljs$core$async$transduce_$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__,f__$1))
})();
var state__9977__auto__ = (function (){var statearr_10803 = f__9976__auto__.call(null);
(statearr_10803[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_10803;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__,f__$1))
);

return c__9975__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args10806 = [];
var len__7484__auto___10858 = arguments.length;
var i__7485__auto___10859 = (0);
while(true){
if((i__7485__auto___10859 < len__7484__auto___10858)){
args10806.push((arguments[i__7485__auto___10859]));

var G__10860 = (i__7485__auto___10859 + (1));
i__7485__auto___10859 = G__10860;
continue;
} else {
}
break;
}

var G__10808 = args10806.length;
switch (G__10808) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10806.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__){
return (function (state_10833){
var state_val_10834 = (state_10833[(1)]);
if((state_val_10834 === (7))){
var inst_10815 = (state_10833[(2)]);
var state_10833__$1 = state_10833;
var statearr_10835_10862 = state_10833__$1;
(statearr_10835_10862[(2)] = inst_10815);

(statearr_10835_10862[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (1))){
var inst_10809 = cljs.core.seq.call(null,coll);
var inst_10810 = inst_10809;
var state_10833__$1 = (function (){var statearr_10836 = state_10833;
(statearr_10836[(7)] = inst_10810);

return statearr_10836;
})();
var statearr_10837_10863 = state_10833__$1;
(statearr_10837_10863[(2)] = null);

(statearr_10837_10863[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (4))){
var inst_10810 = (state_10833[(7)]);
var inst_10813 = cljs.core.first.call(null,inst_10810);
var state_10833__$1 = state_10833;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10833__$1,(7),ch,inst_10813);
} else {
if((state_val_10834 === (13))){
var inst_10827 = (state_10833[(2)]);
var state_10833__$1 = state_10833;
var statearr_10838_10864 = state_10833__$1;
(statearr_10838_10864[(2)] = inst_10827);

(statearr_10838_10864[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (6))){
var inst_10818 = (state_10833[(2)]);
var state_10833__$1 = state_10833;
if(cljs.core.truth_(inst_10818)){
var statearr_10839_10865 = state_10833__$1;
(statearr_10839_10865[(1)] = (8));

} else {
var statearr_10840_10866 = state_10833__$1;
(statearr_10840_10866[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (3))){
var inst_10831 = (state_10833[(2)]);
var state_10833__$1 = state_10833;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10833__$1,inst_10831);
} else {
if((state_val_10834 === (12))){
var state_10833__$1 = state_10833;
var statearr_10841_10867 = state_10833__$1;
(statearr_10841_10867[(2)] = null);

(statearr_10841_10867[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (2))){
var inst_10810 = (state_10833[(7)]);
var state_10833__$1 = state_10833;
if(cljs.core.truth_(inst_10810)){
var statearr_10842_10868 = state_10833__$1;
(statearr_10842_10868[(1)] = (4));

} else {
var statearr_10843_10869 = state_10833__$1;
(statearr_10843_10869[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (11))){
var inst_10824 = cljs.core.async.close_BANG_.call(null,ch);
var state_10833__$1 = state_10833;
var statearr_10844_10870 = state_10833__$1;
(statearr_10844_10870[(2)] = inst_10824);

(statearr_10844_10870[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (9))){
var state_10833__$1 = state_10833;
if(cljs.core.truth_(close_QMARK_)){
var statearr_10845_10871 = state_10833__$1;
(statearr_10845_10871[(1)] = (11));

} else {
var statearr_10846_10872 = state_10833__$1;
(statearr_10846_10872[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (5))){
var inst_10810 = (state_10833[(7)]);
var state_10833__$1 = state_10833;
var statearr_10847_10873 = state_10833__$1;
(statearr_10847_10873[(2)] = inst_10810);

(statearr_10847_10873[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (10))){
var inst_10829 = (state_10833[(2)]);
var state_10833__$1 = state_10833;
var statearr_10848_10874 = state_10833__$1;
(statearr_10848_10874[(2)] = inst_10829);

(statearr_10848_10874[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10834 === (8))){
var inst_10810 = (state_10833[(7)]);
var inst_10820 = cljs.core.next.call(null,inst_10810);
var inst_10810__$1 = inst_10820;
var state_10833__$1 = (function (){var statearr_10849 = state_10833;
(statearr_10849[(7)] = inst_10810__$1);

return statearr_10849;
})();
var statearr_10850_10875 = state_10833__$1;
(statearr_10850_10875[(2)] = null);

(statearr_10850_10875[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto__))
;
return ((function (switch__8768__auto__,c__9975__auto__){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_10854 = [null,null,null,null,null,null,null,null];
(statearr_10854[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_10854[(1)] = (1));

return statearr_10854;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_10833){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_10833);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e10855){if((e10855 instanceof Object)){
var ex__8772__auto__ = e10855;
var statearr_10856_10876 = state_10833;
(statearr_10856_10876[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10833);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10855;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10877 = state_10833;
state_10833 = G__10877;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_10833){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_10833);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__))
})();
var state__9977__auto__ = (function (){var statearr_10857 = f__9976__auto__.call(null);
(statearr_10857[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_10857;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__))
);

return c__9975__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__7072__auto__ = (((_ == null))?null:_);
var m__7073__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,_);
} else {
var m__7073__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__7073__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,ch);
} else {
var m__7073__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m);
} else {
var m__7073__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async11103 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async11103 = (function (mult,ch,cs,meta11104){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta11104 = meta11104;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_11105,meta11104__$1){
var self__ = this;
var _11105__$1 = this;
return (new cljs.core.async.t_cljs$core$async11103(self__.mult,self__.ch,self__.cs,meta11104__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_11105){
var self__ = this;
var _11105__$1 = this;
return self__.meta11104;
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"mult","mult",-1187640995,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta11104","meta11104",1445057581,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async11103.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async11103.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async11103";

cljs.core.async.t_cljs$core$async11103.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async11103");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async11103 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async11103(mult__$1,ch__$1,cs__$1,meta11104){
return (new cljs.core.async.t_cljs$core$async11103(mult__$1,ch__$1,cs__$1,meta11104));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async11103(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__9975__auto___11328 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___11328,cs,m,dchan,dctr,done){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___11328,cs,m,dchan,dctr,done){
return (function (state_11240){
var state_val_11241 = (state_11240[(1)]);
if((state_val_11241 === (7))){
var inst_11236 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11242_11329 = state_11240__$1;
(statearr_11242_11329[(2)] = inst_11236);

(statearr_11242_11329[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (20))){
var inst_11139 = (state_11240[(7)]);
var inst_11151 = cljs.core.first.call(null,inst_11139);
var inst_11152 = cljs.core.nth.call(null,inst_11151,(0),null);
var inst_11153 = cljs.core.nth.call(null,inst_11151,(1),null);
var state_11240__$1 = (function (){var statearr_11243 = state_11240;
(statearr_11243[(8)] = inst_11152);

return statearr_11243;
})();
if(cljs.core.truth_(inst_11153)){
var statearr_11244_11330 = state_11240__$1;
(statearr_11244_11330[(1)] = (22));

} else {
var statearr_11245_11331 = state_11240__$1;
(statearr_11245_11331[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (27))){
var inst_11188 = (state_11240[(9)]);
var inst_11183 = (state_11240[(10)]);
var inst_11181 = (state_11240[(11)]);
var inst_11108 = (state_11240[(12)]);
var inst_11188__$1 = cljs.core._nth.call(null,inst_11181,inst_11183);
var inst_11189 = cljs.core.async.put_BANG_.call(null,inst_11188__$1,inst_11108,done);
var state_11240__$1 = (function (){var statearr_11246 = state_11240;
(statearr_11246[(9)] = inst_11188__$1);

return statearr_11246;
})();
if(cljs.core.truth_(inst_11189)){
var statearr_11247_11332 = state_11240__$1;
(statearr_11247_11332[(1)] = (30));

} else {
var statearr_11248_11333 = state_11240__$1;
(statearr_11248_11333[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (1))){
var state_11240__$1 = state_11240;
var statearr_11249_11334 = state_11240__$1;
(statearr_11249_11334[(2)] = null);

(statearr_11249_11334[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (24))){
var inst_11139 = (state_11240[(7)]);
var inst_11158 = (state_11240[(2)]);
var inst_11159 = cljs.core.next.call(null,inst_11139);
var inst_11117 = inst_11159;
var inst_11118 = null;
var inst_11119 = (0);
var inst_11120 = (0);
var state_11240__$1 = (function (){var statearr_11250 = state_11240;
(statearr_11250[(13)] = inst_11117);

(statearr_11250[(14)] = inst_11120);

(statearr_11250[(15)] = inst_11119);

(statearr_11250[(16)] = inst_11158);

(statearr_11250[(17)] = inst_11118);

return statearr_11250;
})();
var statearr_11251_11335 = state_11240__$1;
(statearr_11251_11335[(2)] = null);

(statearr_11251_11335[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (39))){
var state_11240__$1 = state_11240;
var statearr_11255_11336 = state_11240__$1;
(statearr_11255_11336[(2)] = null);

(statearr_11255_11336[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (4))){
var inst_11108 = (state_11240[(12)]);
var inst_11108__$1 = (state_11240[(2)]);
var inst_11109 = (inst_11108__$1 == null);
var state_11240__$1 = (function (){var statearr_11256 = state_11240;
(statearr_11256[(12)] = inst_11108__$1);

return statearr_11256;
})();
if(cljs.core.truth_(inst_11109)){
var statearr_11257_11337 = state_11240__$1;
(statearr_11257_11337[(1)] = (5));

} else {
var statearr_11258_11338 = state_11240__$1;
(statearr_11258_11338[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (15))){
var inst_11117 = (state_11240[(13)]);
var inst_11120 = (state_11240[(14)]);
var inst_11119 = (state_11240[(15)]);
var inst_11118 = (state_11240[(17)]);
var inst_11135 = (state_11240[(2)]);
var inst_11136 = (inst_11120 + (1));
var tmp11252 = inst_11117;
var tmp11253 = inst_11119;
var tmp11254 = inst_11118;
var inst_11117__$1 = tmp11252;
var inst_11118__$1 = tmp11254;
var inst_11119__$1 = tmp11253;
var inst_11120__$1 = inst_11136;
var state_11240__$1 = (function (){var statearr_11259 = state_11240;
(statearr_11259[(18)] = inst_11135);

(statearr_11259[(13)] = inst_11117__$1);

(statearr_11259[(14)] = inst_11120__$1);

(statearr_11259[(15)] = inst_11119__$1);

(statearr_11259[(17)] = inst_11118__$1);

return statearr_11259;
})();
var statearr_11260_11339 = state_11240__$1;
(statearr_11260_11339[(2)] = null);

(statearr_11260_11339[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (21))){
var inst_11162 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11264_11340 = state_11240__$1;
(statearr_11264_11340[(2)] = inst_11162);

(statearr_11264_11340[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (31))){
var inst_11188 = (state_11240[(9)]);
var inst_11192 = done.call(null,null);
var inst_11193 = cljs.core.async.untap_STAR_.call(null,m,inst_11188);
var state_11240__$1 = (function (){var statearr_11265 = state_11240;
(statearr_11265[(19)] = inst_11192);

return statearr_11265;
})();
var statearr_11266_11341 = state_11240__$1;
(statearr_11266_11341[(2)] = inst_11193);

(statearr_11266_11341[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (32))){
var inst_11182 = (state_11240[(20)]);
var inst_11180 = (state_11240[(21)]);
var inst_11183 = (state_11240[(10)]);
var inst_11181 = (state_11240[(11)]);
var inst_11195 = (state_11240[(2)]);
var inst_11196 = (inst_11183 + (1));
var tmp11261 = inst_11182;
var tmp11262 = inst_11180;
var tmp11263 = inst_11181;
var inst_11180__$1 = tmp11262;
var inst_11181__$1 = tmp11263;
var inst_11182__$1 = tmp11261;
var inst_11183__$1 = inst_11196;
var state_11240__$1 = (function (){var statearr_11267 = state_11240;
(statearr_11267[(20)] = inst_11182__$1);

(statearr_11267[(21)] = inst_11180__$1);

(statearr_11267[(10)] = inst_11183__$1);

(statearr_11267[(22)] = inst_11195);

(statearr_11267[(11)] = inst_11181__$1);

return statearr_11267;
})();
var statearr_11268_11342 = state_11240__$1;
(statearr_11268_11342[(2)] = null);

(statearr_11268_11342[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (40))){
var inst_11208 = (state_11240[(23)]);
var inst_11212 = done.call(null,null);
var inst_11213 = cljs.core.async.untap_STAR_.call(null,m,inst_11208);
var state_11240__$1 = (function (){var statearr_11269 = state_11240;
(statearr_11269[(24)] = inst_11212);

return statearr_11269;
})();
var statearr_11270_11343 = state_11240__$1;
(statearr_11270_11343[(2)] = inst_11213);

(statearr_11270_11343[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (33))){
var inst_11199 = (state_11240[(25)]);
var inst_11201 = cljs.core.chunked_seq_QMARK_.call(null,inst_11199);
var state_11240__$1 = state_11240;
if(inst_11201){
var statearr_11271_11344 = state_11240__$1;
(statearr_11271_11344[(1)] = (36));

} else {
var statearr_11272_11345 = state_11240__$1;
(statearr_11272_11345[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (13))){
var inst_11129 = (state_11240[(26)]);
var inst_11132 = cljs.core.async.close_BANG_.call(null,inst_11129);
var state_11240__$1 = state_11240;
var statearr_11273_11346 = state_11240__$1;
(statearr_11273_11346[(2)] = inst_11132);

(statearr_11273_11346[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (22))){
var inst_11152 = (state_11240[(8)]);
var inst_11155 = cljs.core.async.close_BANG_.call(null,inst_11152);
var state_11240__$1 = state_11240;
var statearr_11274_11347 = state_11240__$1;
(statearr_11274_11347[(2)] = inst_11155);

(statearr_11274_11347[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (36))){
var inst_11199 = (state_11240[(25)]);
var inst_11203 = cljs.core.chunk_first.call(null,inst_11199);
var inst_11204 = cljs.core.chunk_rest.call(null,inst_11199);
var inst_11205 = cljs.core.count.call(null,inst_11203);
var inst_11180 = inst_11204;
var inst_11181 = inst_11203;
var inst_11182 = inst_11205;
var inst_11183 = (0);
var state_11240__$1 = (function (){var statearr_11275 = state_11240;
(statearr_11275[(20)] = inst_11182);

(statearr_11275[(21)] = inst_11180);

(statearr_11275[(10)] = inst_11183);

(statearr_11275[(11)] = inst_11181);

return statearr_11275;
})();
var statearr_11276_11348 = state_11240__$1;
(statearr_11276_11348[(2)] = null);

(statearr_11276_11348[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (41))){
var inst_11199 = (state_11240[(25)]);
var inst_11215 = (state_11240[(2)]);
var inst_11216 = cljs.core.next.call(null,inst_11199);
var inst_11180 = inst_11216;
var inst_11181 = null;
var inst_11182 = (0);
var inst_11183 = (0);
var state_11240__$1 = (function (){var statearr_11277 = state_11240;
(statearr_11277[(27)] = inst_11215);

(statearr_11277[(20)] = inst_11182);

(statearr_11277[(21)] = inst_11180);

(statearr_11277[(10)] = inst_11183);

(statearr_11277[(11)] = inst_11181);

return statearr_11277;
})();
var statearr_11278_11349 = state_11240__$1;
(statearr_11278_11349[(2)] = null);

(statearr_11278_11349[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (43))){
var state_11240__$1 = state_11240;
var statearr_11279_11350 = state_11240__$1;
(statearr_11279_11350[(2)] = null);

(statearr_11279_11350[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (29))){
var inst_11224 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11280_11351 = state_11240__$1;
(statearr_11280_11351[(2)] = inst_11224);

(statearr_11280_11351[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (44))){
var inst_11233 = (state_11240[(2)]);
var state_11240__$1 = (function (){var statearr_11281 = state_11240;
(statearr_11281[(28)] = inst_11233);

return statearr_11281;
})();
var statearr_11282_11352 = state_11240__$1;
(statearr_11282_11352[(2)] = null);

(statearr_11282_11352[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (6))){
var inst_11172 = (state_11240[(29)]);
var inst_11171 = cljs.core.deref.call(null,cs);
var inst_11172__$1 = cljs.core.keys.call(null,inst_11171);
var inst_11173 = cljs.core.count.call(null,inst_11172__$1);
var inst_11174 = cljs.core.reset_BANG_.call(null,dctr,inst_11173);
var inst_11179 = cljs.core.seq.call(null,inst_11172__$1);
var inst_11180 = inst_11179;
var inst_11181 = null;
var inst_11182 = (0);
var inst_11183 = (0);
var state_11240__$1 = (function (){var statearr_11283 = state_11240;
(statearr_11283[(20)] = inst_11182);

(statearr_11283[(21)] = inst_11180);

(statearr_11283[(10)] = inst_11183);

(statearr_11283[(29)] = inst_11172__$1);

(statearr_11283[(11)] = inst_11181);

(statearr_11283[(30)] = inst_11174);

return statearr_11283;
})();
var statearr_11284_11353 = state_11240__$1;
(statearr_11284_11353[(2)] = null);

(statearr_11284_11353[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (28))){
var inst_11180 = (state_11240[(21)]);
var inst_11199 = (state_11240[(25)]);
var inst_11199__$1 = cljs.core.seq.call(null,inst_11180);
var state_11240__$1 = (function (){var statearr_11285 = state_11240;
(statearr_11285[(25)] = inst_11199__$1);

return statearr_11285;
})();
if(inst_11199__$1){
var statearr_11286_11354 = state_11240__$1;
(statearr_11286_11354[(1)] = (33));

} else {
var statearr_11287_11355 = state_11240__$1;
(statearr_11287_11355[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (25))){
var inst_11182 = (state_11240[(20)]);
var inst_11183 = (state_11240[(10)]);
var inst_11185 = (inst_11183 < inst_11182);
var inst_11186 = inst_11185;
var state_11240__$1 = state_11240;
if(cljs.core.truth_(inst_11186)){
var statearr_11288_11356 = state_11240__$1;
(statearr_11288_11356[(1)] = (27));

} else {
var statearr_11289_11357 = state_11240__$1;
(statearr_11289_11357[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (34))){
var state_11240__$1 = state_11240;
var statearr_11290_11358 = state_11240__$1;
(statearr_11290_11358[(2)] = null);

(statearr_11290_11358[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (17))){
var state_11240__$1 = state_11240;
var statearr_11291_11359 = state_11240__$1;
(statearr_11291_11359[(2)] = null);

(statearr_11291_11359[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (3))){
var inst_11238 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11240__$1,inst_11238);
} else {
if((state_val_11241 === (12))){
var inst_11167 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11292_11360 = state_11240__$1;
(statearr_11292_11360[(2)] = inst_11167);

(statearr_11292_11360[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (2))){
var state_11240__$1 = state_11240;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11240__$1,(4),ch);
} else {
if((state_val_11241 === (23))){
var state_11240__$1 = state_11240;
var statearr_11293_11361 = state_11240__$1;
(statearr_11293_11361[(2)] = null);

(statearr_11293_11361[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (35))){
var inst_11222 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11294_11362 = state_11240__$1;
(statearr_11294_11362[(2)] = inst_11222);

(statearr_11294_11362[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (19))){
var inst_11139 = (state_11240[(7)]);
var inst_11143 = cljs.core.chunk_first.call(null,inst_11139);
var inst_11144 = cljs.core.chunk_rest.call(null,inst_11139);
var inst_11145 = cljs.core.count.call(null,inst_11143);
var inst_11117 = inst_11144;
var inst_11118 = inst_11143;
var inst_11119 = inst_11145;
var inst_11120 = (0);
var state_11240__$1 = (function (){var statearr_11295 = state_11240;
(statearr_11295[(13)] = inst_11117);

(statearr_11295[(14)] = inst_11120);

(statearr_11295[(15)] = inst_11119);

(statearr_11295[(17)] = inst_11118);

return statearr_11295;
})();
var statearr_11296_11363 = state_11240__$1;
(statearr_11296_11363[(2)] = null);

(statearr_11296_11363[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (11))){
var inst_11139 = (state_11240[(7)]);
var inst_11117 = (state_11240[(13)]);
var inst_11139__$1 = cljs.core.seq.call(null,inst_11117);
var state_11240__$1 = (function (){var statearr_11297 = state_11240;
(statearr_11297[(7)] = inst_11139__$1);

return statearr_11297;
})();
if(inst_11139__$1){
var statearr_11298_11364 = state_11240__$1;
(statearr_11298_11364[(1)] = (16));

} else {
var statearr_11299_11365 = state_11240__$1;
(statearr_11299_11365[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (9))){
var inst_11169 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11300_11366 = state_11240__$1;
(statearr_11300_11366[(2)] = inst_11169);

(statearr_11300_11366[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (5))){
var inst_11115 = cljs.core.deref.call(null,cs);
var inst_11116 = cljs.core.seq.call(null,inst_11115);
var inst_11117 = inst_11116;
var inst_11118 = null;
var inst_11119 = (0);
var inst_11120 = (0);
var state_11240__$1 = (function (){var statearr_11301 = state_11240;
(statearr_11301[(13)] = inst_11117);

(statearr_11301[(14)] = inst_11120);

(statearr_11301[(15)] = inst_11119);

(statearr_11301[(17)] = inst_11118);

return statearr_11301;
})();
var statearr_11302_11367 = state_11240__$1;
(statearr_11302_11367[(2)] = null);

(statearr_11302_11367[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (14))){
var state_11240__$1 = state_11240;
var statearr_11303_11368 = state_11240__$1;
(statearr_11303_11368[(2)] = null);

(statearr_11303_11368[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (45))){
var inst_11230 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11304_11369 = state_11240__$1;
(statearr_11304_11369[(2)] = inst_11230);

(statearr_11304_11369[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (26))){
var inst_11172 = (state_11240[(29)]);
var inst_11226 = (state_11240[(2)]);
var inst_11227 = cljs.core.seq.call(null,inst_11172);
var state_11240__$1 = (function (){var statearr_11305 = state_11240;
(statearr_11305[(31)] = inst_11226);

return statearr_11305;
})();
if(inst_11227){
var statearr_11306_11370 = state_11240__$1;
(statearr_11306_11370[(1)] = (42));

} else {
var statearr_11307_11371 = state_11240__$1;
(statearr_11307_11371[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (16))){
var inst_11139 = (state_11240[(7)]);
var inst_11141 = cljs.core.chunked_seq_QMARK_.call(null,inst_11139);
var state_11240__$1 = state_11240;
if(inst_11141){
var statearr_11308_11372 = state_11240__$1;
(statearr_11308_11372[(1)] = (19));

} else {
var statearr_11309_11373 = state_11240__$1;
(statearr_11309_11373[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (38))){
var inst_11219 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11310_11374 = state_11240__$1;
(statearr_11310_11374[(2)] = inst_11219);

(statearr_11310_11374[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (30))){
var state_11240__$1 = state_11240;
var statearr_11311_11375 = state_11240__$1;
(statearr_11311_11375[(2)] = null);

(statearr_11311_11375[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (10))){
var inst_11120 = (state_11240[(14)]);
var inst_11118 = (state_11240[(17)]);
var inst_11128 = cljs.core._nth.call(null,inst_11118,inst_11120);
var inst_11129 = cljs.core.nth.call(null,inst_11128,(0),null);
var inst_11130 = cljs.core.nth.call(null,inst_11128,(1),null);
var state_11240__$1 = (function (){var statearr_11312 = state_11240;
(statearr_11312[(26)] = inst_11129);

return statearr_11312;
})();
if(cljs.core.truth_(inst_11130)){
var statearr_11313_11376 = state_11240__$1;
(statearr_11313_11376[(1)] = (13));

} else {
var statearr_11314_11377 = state_11240__$1;
(statearr_11314_11377[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (18))){
var inst_11165 = (state_11240[(2)]);
var state_11240__$1 = state_11240;
var statearr_11315_11378 = state_11240__$1;
(statearr_11315_11378[(2)] = inst_11165);

(statearr_11315_11378[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (42))){
var state_11240__$1 = state_11240;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11240__$1,(45),dchan);
} else {
if((state_val_11241 === (37))){
var inst_11208 = (state_11240[(23)]);
var inst_11199 = (state_11240[(25)]);
var inst_11108 = (state_11240[(12)]);
var inst_11208__$1 = cljs.core.first.call(null,inst_11199);
var inst_11209 = cljs.core.async.put_BANG_.call(null,inst_11208__$1,inst_11108,done);
var state_11240__$1 = (function (){var statearr_11316 = state_11240;
(statearr_11316[(23)] = inst_11208__$1);

return statearr_11316;
})();
if(cljs.core.truth_(inst_11209)){
var statearr_11317_11379 = state_11240__$1;
(statearr_11317_11379[(1)] = (39));

} else {
var statearr_11318_11380 = state_11240__$1;
(statearr_11318_11380[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11241 === (8))){
var inst_11120 = (state_11240[(14)]);
var inst_11119 = (state_11240[(15)]);
var inst_11122 = (inst_11120 < inst_11119);
var inst_11123 = inst_11122;
var state_11240__$1 = state_11240;
if(cljs.core.truth_(inst_11123)){
var statearr_11319_11381 = state_11240__$1;
(statearr_11319_11381[(1)] = (10));

} else {
var statearr_11320_11382 = state_11240__$1;
(statearr_11320_11382[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___11328,cs,m,dchan,dctr,done))
;
return ((function (switch__8768__auto__,c__9975__auto___11328,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__8769__auto__ = null;
var cljs$core$async$mult_$_state_machine__8769__auto____0 = (function (){
var statearr_11324 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11324[(0)] = cljs$core$async$mult_$_state_machine__8769__auto__);

(statearr_11324[(1)] = (1));

return statearr_11324;
});
var cljs$core$async$mult_$_state_machine__8769__auto____1 = (function (state_11240){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_11240);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e11325){if((e11325 instanceof Object)){
var ex__8772__auto__ = e11325;
var statearr_11326_11383 = state_11240;
(statearr_11326_11383[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11240);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11325;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11384 = state_11240;
state_11240 = G__11384;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__8769__auto__ = function(state_11240){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__8769__auto____1.call(this,state_11240);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__8769__auto____0;
cljs$core$async$mult_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__8769__auto____1;
return cljs$core$async$mult_$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___11328,cs,m,dchan,dctr,done))
})();
var state__9977__auto__ = (function (){var statearr_11327 = f__9976__auto__.call(null);
(statearr_11327[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___11328);

return statearr_11327;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___11328,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args11385 = [];
var len__7484__auto___11388 = arguments.length;
var i__7485__auto___11389 = (0);
while(true){
if((i__7485__auto___11389 < len__7484__auto___11388)){
args11385.push((arguments[i__7485__auto___11389]));

var G__11390 = (i__7485__auto___11389 + (1));
i__7485__auto___11389 = G__11390;
continue;
} else {
}
break;
}

var G__11387 = args11385.length;
switch (G__11387) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11385.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,ch);
} else {
var m__7073__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,ch);
} else {
var m__7073__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m);
} else {
var m__7073__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,state_map);
} else {
var m__7073__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__7072__auto__ = (((m == null))?null:m);
var m__7073__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,m,mode);
} else {
var m__7073__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__7491__auto__ = [];
var len__7484__auto___11402 = arguments.length;
var i__7485__auto___11403 = (0);
while(true){
if((i__7485__auto___11403 < len__7484__auto___11402)){
args__7491__auto__.push((arguments[i__7485__auto___11403]));

var G__11404 = (i__7485__auto___11403 + (1));
i__7485__auto___11403 = G__11404;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((3) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__7492__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__11396){
var map__11397 = p__11396;
var map__11397__$1 = ((((!((map__11397 == null)))?((((map__11397.cljs$lang$protocol_mask$partition0$ & (64))) || (map__11397.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__11397):map__11397);
var opts = map__11397__$1;
var statearr_11399_11405 = state;
(statearr_11399_11405[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4657__auto__ = cljs.core.async.do_alts.call(null,((function (map__11397,map__11397__$1,opts){
return (function (val){
var statearr_11400_11406 = state;
(statearr_11400_11406[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__11397,map__11397__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4657__auto__)){
var cb = temp__4657__auto__;
var statearr_11401_11407 = state;
(statearr_11401_11407[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq11392){
var G__11393 = cljs.core.first.call(null,seq11392);
var seq11392__$1 = cljs.core.next.call(null,seq11392);
var G__11394 = cljs.core.first.call(null,seq11392__$1);
var seq11392__$2 = cljs.core.next.call(null,seq11392__$1);
var G__11395 = cljs.core.first.call(null,seq11392__$2);
var seq11392__$3 = cljs.core.next.call(null,seq11392__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__11393,G__11394,G__11395,seq11392__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async11573 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async11573 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta11574){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta11574 = meta11574;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_11575,meta11574__$1){
var self__ = this;
var _11575__$1 = this;
return (new cljs.core.async.t_cljs$core$async11573(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta11574__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_11575){
var self__ = this;
var _11575__$1 = this;
return self__.meta11574;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str("(solo-modes mode)")].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),cljs.core.with_meta(new cljs.core.Symbol(null,"mix","mix",2121373763,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta11574","meta11574",144828616,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async11573.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async11573.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async11573";

cljs.core.async.t_cljs$core$async11573.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async11573");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async11573 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async11573(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta11574){
return (new cljs.core.async.t_cljs$core$async11573(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta11574));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async11573(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__9975__auto___11738 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_11675){
var state_val_11676 = (state_11675[(1)]);
if((state_val_11676 === (7))){
var inst_11591 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
var statearr_11677_11739 = state_11675__$1;
(statearr_11677_11739[(2)] = inst_11591);

(statearr_11677_11739[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (20))){
var inst_11603 = (state_11675[(7)]);
var state_11675__$1 = state_11675;
var statearr_11678_11740 = state_11675__$1;
(statearr_11678_11740[(2)] = inst_11603);

(statearr_11678_11740[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (27))){
var state_11675__$1 = state_11675;
var statearr_11679_11741 = state_11675__$1;
(statearr_11679_11741[(2)] = null);

(statearr_11679_11741[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (1))){
var inst_11579 = (state_11675[(8)]);
var inst_11579__$1 = calc_state.call(null);
var inst_11581 = (inst_11579__$1 == null);
var inst_11582 = cljs.core.not.call(null,inst_11581);
var state_11675__$1 = (function (){var statearr_11680 = state_11675;
(statearr_11680[(8)] = inst_11579__$1);

return statearr_11680;
})();
if(inst_11582){
var statearr_11681_11742 = state_11675__$1;
(statearr_11681_11742[(1)] = (2));

} else {
var statearr_11682_11743 = state_11675__$1;
(statearr_11682_11743[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (24))){
var inst_11635 = (state_11675[(9)]);
var inst_11649 = (state_11675[(10)]);
var inst_11626 = (state_11675[(11)]);
var inst_11649__$1 = inst_11626.call(null,inst_11635);
var state_11675__$1 = (function (){var statearr_11683 = state_11675;
(statearr_11683[(10)] = inst_11649__$1);

return statearr_11683;
})();
if(cljs.core.truth_(inst_11649__$1)){
var statearr_11684_11744 = state_11675__$1;
(statearr_11684_11744[(1)] = (29));

} else {
var statearr_11685_11745 = state_11675__$1;
(statearr_11685_11745[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (4))){
var inst_11594 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11594)){
var statearr_11686_11746 = state_11675__$1;
(statearr_11686_11746[(1)] = (8));

} else {
var statearr_11687_11747 = state_11675__$1;
(statearr_11687_11747[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (15))){
var inst_11620 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11620)){
var statearr_11688_11748 = state_11675__$1;
(statearr_11688_11748[(1)] = (19));

} else {
var statearr_11689_11749 = state_11675__$1;
(statearr_11689_11749[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (21))){
var inst_11625 = (state_11675[(12)]);
var inst_11625__$1 = (state_11675[(2)]);
var inst_11626 = cljs.core.get.call(null,inst_11625__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_11627 = cljs.core.get.call(null,inst_11625__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_11628 = cljs.core.get.call(null,inst_11625__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_11675__$1 = (function (){var statearr_11690 = state_11675;
(statearr_11690[(12)] = inst_11625__$1);

(statearr_11690[(11)] = inst_11626);

(statearr_11690[(13)] = inst_11627);

return statearr_11690;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_11675__$1,(22),inst_11628);
} else {
if((state_val_11676 === (31))){
var inst_11657 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11657)){
var statearr_11691_11750 = state_11675__$1;
(statearr_11691_11750[(1)] = (32));

} else {
var statearr_11692_11751 = state_11675__$1;
(statearr_11692_11751[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (32))){
var inst_11634 = (state_11675[(14)]);
var state_11675__$1 = state_11675;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11675__$1,(35),out,inst_11634);
} else {
if((state_val_11676 === (33))){
var inst_11625 = (state_11675[(12)]);
var inst_11603 = inst_11625;
var state_11675__$1 = (function (){var statearr_11693 = state_11675;
(statearr_11693[(7)] = inst_11603);

return statearr_11693;
})();
var statearr_11694_11752 = state_11675__$1;
(statearr_11694_11752[(2)] = null);

(statearr_11694_11752[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (13))){
var inst_11603 = (state_11675[(7)]);
var inst_11610 = inst_11603.cljs$lang$protocol_mask$partition0$;
var inst_11611 = (inst_11610 & (64));
var inst_11612 = inst_11603.cljs$core$ISeq$;
var inst_11613 = (inst_11611) || (inst_11612);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11613)){
var statearr_11695_11753 = state_11675__$1;
(statearr_11695_11753[(1)] = (16));

} else {
var statearr_11696_11754 = state_11675__$1;
(statearr_11696_11754[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (22))){
var inst_11635 = (state_11675[(9)]);
var inst_11634 = (state_11675[(14)]);
var inst_11633 = (state_11675[(2)]);
var inst_11634__$1 = cljs.core.nth.call(null,inst_11633,(0),null);
var inst_11635__$1 = cljs.core.nth.call(null,inst_11633,(1),null);
var inst_11636 = (inst_11634__$1 == null);
var inst_11637 = cljs.core._EQ_.call(null,inst_11635__$1,change);
var inst_11638 = (inst_11636) || (inst_11637);
var state_11675__$1 = (function (){var statearr_11697 = state_11675;
(statearr_11697[(9)] = inst_11635__$1);

(statearr_11697[(14)] = inst_11634__$1);

return statearr_11697;
})();
if(cljs.core.truth_(inst_11638)){
var statearr_11698_11755 = state_11675__$1;
(statearr_11698_11755[(1)] = (23));

} else {
var statearr_11699_11756 = state_11675__$1;
(statearr_11699_11756[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (36))){
var inst_11625 = (state_11675[(12)]);
var inst_11603 = inst_11625;
var state_11675__$1 = (function (){var statearr_11700 = state_11675;
(statearr_11700[(7)] = inst_11603);

return statearr_11700;
})();
var statearr_11701_11757 = state_11675__$1;
(statearr_11701_11757[(2)] = null);

(statearr_11701_11757[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (29))){
var inst_11649 = (state_11675[(10)]);
var state_11675__$1 = state_11675;
var statearr_11702_11758 = state_11675__$1;
(statearr_11702_11758[(2)] = inst_11649);

(statearr_11702_11758[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (6))){
var state_11675__$1 = state_11675;
var statearr_11703_11759 = state_11675__$1;
(statearr_11703_11759[(2)] = false);

(statearr_11703_11759[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (28))){
var inst_11645 = (state_11675[(2)]);
var inst_11646 = calc_state.call(null);
var inst_11603 = inst_11646;
var state_11675__$1 = (function (){var statearr_11704 = state_11675;
(statearr_11704[(15)] = inst_11645);

(statearr_11704[(7)] = inst_11603);

return statearr_11704;
})();
var statearr_11705_11760 = state_11675__$1;
(statearr_11705_11760[(2)] = null);

(statearr_11705_11760[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (25))){
var inst_11671 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
var statearr_11706_11761 = state_11675__$1;
(statearr_11706_11761[(2)] = inst_11671);

(statearr_11706_11761[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (34))){
var inst_11669 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
var statearr_11707_11762 = state_11675__$1;
(statearr_11707_11762[(2)] = inst_11669);

(statearr_11707_11762[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (17))){
var state_11675__$1 = state_11675;
var statearr_11708_11763 = state_11675__$1;
(statearr_11708_11763[(2)] = false);

(statearr_11708_11763[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (3))){
var state_11675__$1 = state_11675;
var statearr_11709_11764 = state_11675__$1;
(statearr_11709_11764[(2)] = false);

(statearr_11709_11764[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (12))){
var inst_11673 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11675__$1,inst_11673);
} else {
if((state_val_11676 === (2))){
var inst_11579 = (state_11675[(8)]);
var inst_11584 = inst_11579.cljs$lang$protocol_mask$partition0$;
var inst_11585 = (inst_11584 & (64));
var inst_11586 = inst_11579.cljs$core$ISeq$;
var inst_11587 = (inst_11585) || (inst_11586);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11587)){
var statearr_11710_11765 = state_11675__$1;
(statearr_11710_11765[(1)] = (5));

} else {
var statearr_11711_11766 = state_11675__$1;
(statearr_11711_11766[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (23))){
var inst_11634 = (state_11675[(14)]);
var inst_11640 = (inst_11634 == null);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11640)){
var statearr_11712_11767 = state_11675__$1;
(statearr_11712_11767[(1)] = (26));

} else {
var statearr_11713_11768 = state_11675__$1;
(statearr_11713_11768[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (35))){
var inst_11660 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
if(cljs.core.truth_(inst_11660)){
var statearr_11714_11769 = state_11675__$1;
(statearr_11714_11769[(1)] = (36));

} else {
var statearr_11715_11770 = state_11675__$1;
(statearr_11715_11770[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (19))){
var inst_11603 = (state_11675[(7)]);
var inst_11622 = cljs.core.apply.call(null,cljs.core.hash_map,inst_11603);
var state_11675__$1 = state_11675;
var statearr_11716_11771 = state_11675__$1;
(statearr_11716_11771[(2)] = inst_11622);

(statearr_11716_11771[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (11))){
var inst_11603 = (state_11675[(7)]);
var inst_11607 = (inst_11603 == null);
var inst_11608 = cljs.core.not.call(null,inst_11607);
var state_11675__$1 = state_11675;
if(inst_11608){
var statearr_11717_11772 = state_11675__$1;
(statearr_11717_11772[(1)] = (13));

} else {
var statearr_11718_11773 = state_11675__$1;
(statearr_11718_11773[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (9))){
var inst_11579 = (state_11675[(8)]);
var state_11675__$1 = state_11675;
var statearr_11719_11774 = state_11675__$1;
(statearr_11719_11774[(2)] = inst_11579);

(statearr_11719_11774[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (5))){
var state_11675__$1 = state_11675;
var statearr_11720_11775 = state_11675__$1;
(statearr_11720_11775[(2)] = true);

(statearr_11720_11775[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (14))){
var state_11675__$1 = state_11675;
var statearr_11721_11776 = state_11675__$1;
(statearr_11721_11776[(2)] = false);

(statearr_11721_11776[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (26))){
var inst_11635 = (state_11675[(9)]);
var inst_11642 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_11635);
var state_11675__$1 = state_11675;
var statearr_11722_11777 = state_11675__$1;
(statearr_11722_11777[(2)] = inst_11642);

(statearr_11722_11777[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (16))){
var state_11675__$1 = state_11675;
var statearr_11723_11778 = state_11675__$1;
(statearr_11723_11778[(2)] = true);

(statearr_11723_11778[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (38))){
var inst_11665 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
var statearr_11724_11779 = state_11675__$1;
(statearr_11724_11779[(2)] = inst_11665);

(statearr_11724_11779[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (30))){
var inst_11635 = (state_11675[(9)]);
var inst_11626 = (state_11675[(11)]);
var inst_11627 = (state_11675[(13)]);
var inst_11652 = cljs.core.empty_QMARK_.call(null,inst_11626);
var inst_11653 = inst_11627.call(null,inst_11635);
var inst_11654 = cljs.core.not.call(null,inst_11653);
var inst_11655 = (inst_11652) && (inst_11654);
var state_11675__$1 = state_11675;
var statearr_11725_11780 = state_11675__$1;
(statearr_11725_11780[(2)] = inst_11655);

(statearr_11725_11780[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (10))){
var inst_11579 = (state_11675[(8)]);
var inst_11599 = (state_11675[(2)]);
var inst_11600 = cljs.core.get.call(null,inst_11599,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_11601 = cljs.core.get.call(null,inst_11599,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_11602 = cljs.core.get.call(null,inst_11599,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_11603 = inst_11579;
var state_11675__$1 = (function (){var statearr_11726 = state_11675;
(statearr_11726[(16)] = inst_11601);

(statearr_11726[(17)] = inst_11600);

(statearr_11726[(18)] = inst_11602);

(statearr_11726[(7)] = inst_11603);

return statearr_11726;
})();
var statearr_11727_11781 = state_11675__$1;
(statearr_11727_11781[(2)] = null);

(statearr_11727_11781[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (18))){
var inst_11617 = (state_11675[(2)]);
var state_11675__$1 = state_11675;
var statearr_11728_11782 = state_11675__$1;
(statearr_11728_11782[(2)] = inst_11617);

(statearr_11728_11782[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (37))){
var state_11675__$1 = state_11675;
var statearr_11729_11783 = state_11675__$1;
(statearr_11729_11783[(2)] = null);

(statearr_11729_11783[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11676 === (8))){
var inst_11579 = (state_11675[(8)]);
var inst_11596 = cljs.core.apply.call(null,cljs.core.hash_map,inst_11579);
var state_11675__$1 = state_11675;
var statearr_11730_11784 = state_11675__$1;
(statearr_11730_11784[(2)] = inst_11596);

(statearr_11730_11784[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__8768__auto__,c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__8769__auto__ = null;
var cljs$core$async$mix_$_state_machine__8769__auto____0 = (function (){
var statearr_11734 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11734[(0)] = cljs$core$async$mix_$_state_machine__8769__auto__);

(statearr_11734[(1)] = (1));

return statearr_11734;
});
var cljs$core$async$mix_$_state_machine__8769__auto____1 = (function (state_11675){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_11675);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e11735){if((e11735 instanceof Object)){
var ex__8772__auto__ = e11735;
var statearr_11736_11785 = state_11675;
(statearr_11736_11785[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11675);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11735;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11786 = state_11675;
state_11675 = G__11786;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__8769__auto__ = function(state_11675){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__8769__auto____1.call(this,state_11675);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__8769__auto____0;
cljs$core$async$mix_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__8769__auto____1;
return cljs$core$async$mix_$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__9977__auto__ = (function (){var statearr_11737 = f__9976__auto__.call(null);
(statearr_11737[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___11738);

return statearr_11737;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___11738,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__7072__auto__ = (((p == null))?null:p);
var m__7073__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__7073__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__7072__auto__ = (((p == null))?null:p);
var m__7073__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,p,v,ch);
} else {
var m__7073__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args11787 = [];
var len__7484__auto___11790 = arguments.length;
var i__7485__auto___11791 = (0);
while(true){
if((i__7485__auto___11791 < len__7484__auto___11790)){
args11787.push((arguments[i__7485__auto___11791]));

var G__11792 = (i__7485__auto___11791 + (1));
i__7485__auto___11791 = G__11792;
continue;
} else {
}
break;
}

var G__11789 = args11787.length;
switch (G__11789) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11787.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__7072__auto__ = (((p == null))?null:p);
var m__7073__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,p);
} else {
var m__7073__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__7072__auto__ = (((p == null))?null:p);
var m__7073__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,p,v);
} else {
var m__7073__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args11795 = [];
var len__7484__auto___11920 = arguments.length;
var i__7485__auto___11921 = (0);
while(true){
if((i__7485__auto___11921 < len__7484__auto___11920)){
args11795.push((arguments[i__7485__auto___11921]));

var G__11922 = (i__7485__auto___11921 + (1));
i__7485__auto___11921 = G__11922;
continue;
} else {
}
break;
}

var G__11797 = args11795.length;
switch (G__11797) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11795.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__6409__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__6409__auto__,mults){
return (function (p1__11794_SHARP_){
if(cljs.core.truth_(p1__11794_SHARP_.call(null,topic))){
return p1__11794_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__11794_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__6409__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async11798 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async11798 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta11799){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta11799 = meta11799;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_11800,meta11799__$1){
var self__ = this;
var _11800__$1 = this;
return (new cljs.core.async.t_cljs$core$async11798(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta11799__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_11800){
var self__ = this;
var _11800__$1 = this;
return self__.meta11799;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4657__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4657__auto__)){
var m = temp__4657__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta11799","meta11799",1527241212,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async11798.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async11798.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async11798";

cljs.core.async.t_cljs$core$async11798.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async11798");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async11798 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async11798(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta11799){
return (new cljs.core.async.t_cljs$core$async11798(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta11799));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async11798(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__9975__auto___11924 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___11924,mults,ensure_mult,p){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___11924,mults,ensure_mult,p){
return (function (state_11872){
var state_val_11873 = (state_11872[(1)]);
if((state_val_11873 === (7))){
var inst_11868 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11874_11925 = state_11872__$1;
(statearr_11874_11925[(2)] = inst_11868);

(statearr_11874_11925[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (20))){
var state_11872__$1 = state_11872;
var statearr_11875_11926 = state_11872__$1;
(statearr_11875_11926[(2)] = null);

(statearr_11875_11926[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (1))){
var state_11872__$1 = state_11872;
var statearr_11876_11927 = state_11872__$1;
(statearr_11876_11927[(2)] = null);

(statearr_11876_11927[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (24))){
var inst_11851 = (state_11872[(7)]);
var inst_11860 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_11851);
var state_11872__$1 = state_11872;
var statearr_11877_11928 = state_11872__$1;
(statearr_11877_11928[(2)] = inst_11860);

(statearr_11877_11928[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (4))){
var inst_11803 = (state_11872[(8)]);
var inst_11803__$1 = (state_11872[(2)]);
var inst_11804 = (inst_11803__$1 == null);
var state_11872__$1 = (function (){var statearr_11878 = state_11872;
(statearr_11878[(8)] = inst_11803__$1);

return statearr_11878;
})();
if(cljs.core.truth_(inst_11804)){
var statearr_11879_11929 = state_11872__$1;
(statearr_11879_11929[(1)] = (5));

} else {
var statearr_11880_11930 = state_11872__$1;
(statearr_11880_11930[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (15))){
var inst_11845 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11881_11931 = state_11872__$1;
(statearr_11881_11931[(2)] = inst_11845);

(statearr_11881_11931[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (21))){
var inst_11865 = (state_11872[(2)]);
var state_11872__$1 = (function (){var statearr_11882 = state_11872;
(statearr_11882[(9)] = inst_11865);

return statearr_11882;
})();
var statearr_11883_11932 = state_11872__$1;
(statearr_11883_11932[(2)] = null);

(statearr_11883_11932[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (13))){
var inst_11827 = (state_11872[(10)]);
var inst_11829 = cljs.core.chunked_seq_QMARK_.call(null,inst_11827);
var state_11872__$1 = state_11872;
if(inst_11829){
var statearr_11884_11933 = state_11872__$1;
(statearr_11884_11933[(1)] = (16));

} else {
var statearr_11885_11934 = state_11872__$1;
(statearr_11885_11934[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (22))){
var inst_11857 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
if(cljs.core.truth_(inst_11857)){
var statearr_11886_11935 = state_11872__$1;
(statearr_11886_11935[(1)] = (23));

} else {
var statearr_11887_11936 = state_11872__$1;
(statearr_11887_11936[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (6))){
var inst_11853 = (state_11872[(11)]);
var inst_11803 = (state_11872[(8)]);
var inst_11851 = (state_11872[(7)]);
var inst_11851__$1 = topic_fn.call(null,inst_11803);
var inst_11852 = cljs.core.deref.call(null,mults);
var inst_11853__$1 = cljs.core.get.call(null,inst_11852,inst_11851__$1);
var state_11872__$1 = (function (){var statearr_11888 = state_11872;
(statearr_11888[(11)] = inst_11853__$1);

(statearr_11888[(7)] = inst_11851__$1);

return statearr_11888;
})();
if(cljs.core.truth_(inst_11853__$1)){
var statearr_11889_11937 = state_11872__$1;
(statearr_11889_11937[(1)] = (19));

} else {
var statearr_11890_11938 = state_11872__$1;
(statearr_11890_11938[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (25))){
var inst_11862 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11891_11939 = state_11872__$1;
(statearr_11891_11939[(2)] = inst_11862);

(statearr_11891_11939[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (17))){
var inst_11827 = (state_11872[(10)]);
var inst_11836 = cljs.core.first.call(null,inst_11827);
var inst_11837 = cljs.core.async.muxch_STAR_.call(null,inst_11836);
var inst_11838 = cljs.core.async.close_BANG_.call(null,inst_11837);
var inst_11839 = cljs.core.next.call(null,inst_11827);
var inst_11813 = inst_11839;
var inst_11814 = null;
var inst_11815 = (0);
var inst_11816 = (0);
var state_11872__$1 = (function (){var statearr_11892 = state_11872;
(statearr_11892[(12)] = inst_11816);

(statearr_11892[(13)] = inst_11814);

(statearr_11892[(14)] = inst_11813);

(statearr_11892[(15)] = inst_11815);

(statearr_11892[(16)] = inst_11838);

return statearr_11892;
})();
var statearr_11893_11940 = state_11872__$1;
(statearr_11893_11940[(2)] = null);

(statearr_11893_11940[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (3))){
var inst_11870 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11872__$1,inst_11870);
} else {
if((state_val_11873 === (12))){
var inst_11847 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11894_11941 = state_11872__$1;
(statearr_11894_11941[(2)] = inst_11847);

(statearr_11894_11941[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (2))){
var state_11872__$1 = state_11872;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11872__$1,(4),ch);
} else {
if((state_val_11873 === (23))){
var state_11872__$1 = state_11872;
var statearr_11895_11942 = state_11872__$1;
(statearr_11895_11942[(2)] = null);

(statearr_11895_11942[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (19))){
var inst_11853 = (state_11872[(11)]);
var inst_11803 = (state_11872[(8)]);
var inst_11855 = cljs.core.async.muxch_STAR_.call(null,inst_11853);
var state_11872__$1 = state_11872;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11872__$1,(22),inst_11855,inst_11803);
} else {
if((state_val_11873 === (11))){
var inst_11813 = (state_11872[(14)]);
var inst_11827 = (state_11872[(10)]);
var inst_11827__$1 = cljs.core.seq.call(null,inst_11813);
var state_11872__$1 = (function (){var statearr_11896 = state_11872;
(statearr_11896[(10)] = inst_11827__$1);

return statearr_11896;
})();
if(inst_11827__$1){
var statearr_11897_11943 = state_11872__$1;
(statearr_11897_11943[(1)] = (13));

} else {
var statearr_11898_11944 = state_11872__$1;
(statearr_11898_11944[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (9))){
var inst_11849 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11899_11945 = state_11872__$1;
(statearr_11899_11945[(2)] = inst_11849);

(statearr_11899_11945[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (5))){
var inst_11810 = cljs.core.deref.call(null,mults);
var inst_11811 = cljs.core.vals.call(null,inst_11810);
var inst_11812 = cljs.core.seq.call(null,inst_11811);
var inst_11813 = inst_11812;
var inst_11814 = null;
var inst_11815 = (0);
var inst_11816 = (0);
var state_11872__$1 = (function (){var statearr_11900 = state_11872;
(statearr_11900[(12)] = inst_11816);

(statearr_11900[(13)] = inst_11814);

(statearr_11900[(14)] = inst_11813);

(statearr_11900[(15)] = inst_11815);

return statearr_11900;
})();
var statearr_11901_11946 = state_11872__$1;
(statearr_11901_11946[(2)] = null);

(statearr_11901_11946[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (14))){
var state_11872__$1 = state_11872;
var statearr_11905_11947 = state_11872__$1;
(statearr_11905_11947[(2)] = null);

(statearr_11905_11947[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (16))){
var inst_11827 = (state_11872[(10)]);
var inst_11831 = cljs.core.chunk_first.call(null,inst_11827);
var inst_11832 = cljs.core.chunk_rest.call(null,inst_11827);
var inst_11833 = cljs.core.count.call(null,inst_11831);
var inst_11813 = inst_11832;
var inst_11814 = inst_11831;
var inst_11815 = inst_11833;
var inst_11816 = (0);
var state_11872__$1 = (function (){var statearr_11906 = state_11872;
(statearr_11906[(12)] = inst_11816);

(statearr_11906[(13)] = inst_11814);

(statearr_11906[(14)] = inst_11813);

(statearr_11906[(15)] = inst_11815);

return statearr_11906;
})();
var statearr_11907_11948 = state_11872__$1;
(statearr_11907_11948[(2)] = null);

(statearr_11907_11948[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (10))){
var inst_11816 = (state_11872[(12)]);
var inst_11814 = (state_11872[(13)]);
var inst_11813 = (state_11872[(14)]);
var inst_11815 = (state_11872[(15)]);
var inst_11821 = cljs.core._nth.call(null,inst_11814,inst_11816);
var inst_11822 = cljs.core.async.muxch_STAR_.call(null,inst_11821);
var inst_11823 = cljs.core.async.close_BANG_.call(null,inst_11822);
var inst_11824 = (inst_11816 + (1));
var tmp11902 = inst_11814;
var tmp11903 = inst_11813;
var tmp11904 = inst_11815;
var inst_11813__$1 = tmp11903;
var inst_11814__$1 = tmp11902;
var inst_11815__$1 = tmp11904;
var inst_11816__$1 = inst_11824;
var state_11872__$1 = (function (){var statearr_11908 = state_11872;
(statearr_11908[(17)] = inst_11823);

(statearr_11908[(12)] = inst_11816__$1);

(statearr_11908[(13)] = inst_11814__$1);

(statearr_11908[(14)] = inst_11813__$1);

(statearr_11908[(15)] = inst_11815__$1);

return statearr_11908;
})();
var statearr_11909_11949 = state_11872__$1;
(statearr_11909_11949[(2)] = null);

(statearr_11909_11949[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (18))){
var inst_11842 = (state_11872[(2)]);
var state_11872__$1 = state_11872;
var statearr_11910_11950 = state_11872__$1;
(statearr_11910_11950[(2)] = inst_11842);

(statearr_11910_11950[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11873 === (8))){
var inst_11816 = (state_11872[(12)]);
var inst_11815 = (state_11872[(15)]);
var inst_11818 = (inst_11816 < inst_11815);
var inst_11819 = inst_11818;
var state_11872__$1 = state_11872;
if(cljs.core.truth_(inst_11819)){
var statearr_11911_11951 = state_11872__$1;
(statearr_11911_11951[(1)] = (10));

} else {
var statearr_11912_11952 = state_11872__$1;
(statearr_11912_11952[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___11924,mults,ensure_mult,p))
;
return ((function (switch__8768__auto__,c__9975__auto___11924,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_11916 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11916[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_11916[(1)] = (1));

return statearr_11916;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_11872){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_11872);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e11917){if((e11917 instanceof Object)){
var ex__8772__auto__ = e11917;
var statearr_11918_11953 = state_11872;
(statearr_11918_11953[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11872);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11917;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11954 = state_11872;
state_11872 = G__11954;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_11872){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_11872);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___11924,mults,ensure_mult,p))
})();
var state__9977__auto__ = (function (){var statearr_11919 = f__9976__auto__.call(null);
(statearr_11919[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___11924);

return statearr_11919;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___11924,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args11955 = [];
var len__7484__auto___11958 = arguments.length;
var i__7485__auto___11959 = (0);
while(true){
if((i__7485__auto___11959 < len__7484__auto___11958)){
args11955.push((arguments[i__7485__auto___11959]));

var G__11960 = (i__7485__auto___11959 + (1));
i__7485__auto___11959 = G__11960;
continue;
} else {
}
break;
}

var G__11957 = args11955.length;
switch (G__11957) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11955.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args11962 = [];
var len__7484__auto___11965 = arguments.length;
var i__7485__auto___11966 = (0);
while(true){
if((i__7485__auto___11966 < len__7484__auto___11965)){
args11962.push((arguments[i__7485__auto___11966]));

var G__11967 = (i__7485__auto___11966 + (1));
i__7485__auto___11966 = G__11967;
continue;
} else {
}
break;
}

var G__11964 = args11962.length;
switch (G__11964) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11962.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args11969 = [];
var len__7484__auto___12040 = arguments.length;
var i__7485__auto___12041 = (0);
while(true){
if((i__7485__auto___12041 < len__7484__auto___12040)){
args11969.push((arguments[i__7485__auto___12041]));

var G__12042 = (i__7485__auto___12041 + (1));
i__7485__auto___12041 = G__12042;
continue;
} else {
}
break;
}

var G__11971 = args11969.length;
switch (G__11971) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11969.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__9975__auto___12044 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_12010){
var state_val_12011 = (state_12010[(1)]);
if((state_val_12011 === (7))){
var state_12010__$1 = state_12010;
var statearr_12012_12045 = state_12010__$1;
(statearr_12012_12045[(2)] = null);

(statearr_12012_12045[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (1))){
var state_12010__$1 = state_12010;
var statearr_12013_12046 = state_12010__$1;
(statearr_12013_12046[(2)] = null);

(statearr_12013_12046[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (4))){
var inst_11974 = (state_12010[(7)]);
var inst_11976 = (inst_11974 < cnt);
var state_12010__$1 = state_12010;
if(cljs.core.truth_(inst_11976)){
var statearr_12014_12047 = state_12010__$1;
(statearr_12014_12047[(1)] = (6));

} else {
var statearr_12015_12048 = state_12010__$1;
(statearr_12015_12048[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (15))){
var inst_12006 = (state_12010[(2)]);
var state_12010__$1 = state_12010;
var statearr_12016_12049 = state_12010__$1;
(statearr_12016_12049[(2)] = inst_12006);

(statearr_12016_12049[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (13))){
var inst_11999 = cljs.core.async.close_BANG_.call(null,out);
var state_12010__$1 = state_12010;
var statearr_12017_12050 = state_12010__$1;
(statearr_12017_12050[(2)] = inst_11999);

(statearr_12017_12050[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (6))){
var state_12010__$1 = state_12010;
var statearr_12018_12051 = state_12010__$1;
(statearr_12018_12051[(2)] = null);

(statearr_12018_12051[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (3))){
var inst_12008 = (state_12010[(2)]);
var state_12010__$1 = state_12010;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12010__$1,inst_12008);
} else {
if((state_val_12011 === (12))){
var inst_11996 = (state_12010[(8)]);
var inst_11996__$1 = (state_12010[(2)]);
var inst_11997 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_11996__$1);
var state_12010__$1 = (function (){var statearr_12019 = state_12010;
(statearr_12019[(8)] = inst_11996__$1);

return statearr_12019;
})();
if(cljs.core.truth_(inst_11997)){
var statearr_12020_12052 = state_12010__$1;
(statearr_12020_12052[(1)] = (13));

} else {
var statearr_12021_12053 = state_12010__$1;
(statearr_12021_12053[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (2))){
var inst_11973 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_11974 = (0);
var state_12010__$1 = (function (){var statearr_12022 = state_12010;
(statearr_12022[(7)] = inst_11974);

(statearr_12022[(9)] = inst_11973);

return statearr_12022;
})();
var statearr_12023_12054 = state_12010__$1;
(statearr_12023_12054[(2)] = null);

(statearr_12023_12054[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (11))){
var inst_11974 = (state_12010[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_12010,(10),Object,null,(9));
var inst_11983 = chs__$1.call(null,inst_11974);
var inst_11984 = done.call(null,inst_11974);
var inst_11985 = cljs.core.async.take_BANG_.call(null,inst_11983,inst_11984);
var state_12010__$1 = state_12010;
var statearr_12024_12055 = state_12010__$1;
(statearr_12024_12055[(2)] = inst_11985);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12010__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (9))){
var inst_11974 = (state_12010[(7)]);
var inst_11987 = (state_12010[(2)]);
var inst_11988 = (inst_11974 + (1));
var inst_11974__$1 = inst_11988;
var state_12010__$1 = (function (){var statearr_12025 = state_12010;
(statearr_12025[(7)] = inst_11974__$1);

(statearr_12025[(10)] = inst_11987);

return statearr_12025;
})();
var statearr_12026_12056 = state_12010__$1;
(statearr_12026_12056[(2)] = null);

(statearr_12026_12056[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (5))){
var inst_11994 = (state_12010[(2)]);
var state_12010__$1 = (function (){var statearr_12027 = state_12010;
(statearr_12027[(11)] = inst_11994);

return statearr_12027;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12010__$1,(12),dchan);
} else {
if((state_val_12011 === (14))){
var inst_11996 = (state_12010[(8)]);
var inst_12001 = cljs.core.apply.call(null,f,inst_11996);
var state_12010__$1 = state_12010;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12010__$1,(16),out,inst_12001);
} else {
if((state_val_12011 === (16))){
var inst_12003 = (state_12010[(2)]);
var state_12010__$1 = (function (){var statearr_12028 = state_12010;
(statearr_12028[(12)] = inst_12003);

return statearr_12028;
})();
var statearr_12029_12057 = state_12010__$1;
(statearr_12029_12057[(2)] = null);

(statearr_12029_12057[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (10))){
var inst_11978 = (state_12010[(2)]);
var inst_11979 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_12010__$1 = (function (){var statearr_12030 = state_12010;
(statearr_12030[(13)] = inst_11978);

return statearr_12030;
})();
var statearr_12031_12058 = state_12010__$1;
(statearr_12031_12058[(2)] = inst_11979);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12010__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12011 === (8))){
var inst_11992 = (state_12010[(2)]);
var state_12010__$1 = state_12010;
var statearr_12032_12059 = state_12010__$1;
(statearr_12032_12059[(2)] = inst_11992);

(statearr_12032_12059[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__8768__auto__,c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12036 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12036[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12036[(1)] = (1));

return statearr_12036;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12010){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12010);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12037){if((e12037 instanceof Object)){
var ex__8772__auto__ = e12037;
var statearr_12038_12060 = state_12010;
(statearr_12038_12060[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12010);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12037;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12061 = state_12010;
state_12010 = G__12061;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12010){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12010);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__9977__auto__ = (function (){var statearr_12039 = f__9976__auto__.call(null);
(statearr_12039[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12044);

return statearr_12039;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12044,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args12063 = [];
var len__7484__auto___12121 = arguments.length;
var i__7485__auto___12122 = (0);
while(true){
if((i__7485__auto___12122 < len__7484__auto___12121)){
args12063.push((arguments[i__7485__auto___12122]));

var G__12123 = (i__7485__auto___12122 + (1));
i__7485__auto___12122 = G__12123;
continue;
} else {
}
break;
}

var G__12065 = args12063.length;
switch (G__12065) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12063.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12125 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12125,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12125,out){
return (function (state_12097){
var state_val_12098 = (state_12097[(1)]);
if((state_val_12098 === (7))){
var inst_12077 = (state_12097[(7)]);
var inst_12076 = (state_12097[(8)]);
var inst_12076__$1 = (state_12097[(2)]);
var inst_12077__$1 = cljs.core.nth.call(null,inst_12076__$1,(0),null);
var inst_12078 = cljs.core.nth.call(null,inst_12076__$1,(1),null);
var inst_12079 = (inst_12077__$1 == null);
var state_12097__$1 = (function (){var statearr_12099 = state_12097;
(statearr_12099[(7)] = inst_12077__$1);

(statearr_12099[(8)] = inst_12076__$1);

(statearr_12099[(9)] = inst_12078);

return statearr_12099;
})();
if(cljs.core.truth_(inst_12079)){
var statearr_12100_12126 = state_12097__$1;
(statearr_12100_12126[(1)] = (8));

} else {
var statearr_12101_12127 = state_12097__$1;
(statearr_12101_12127[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (1))){
var inst_12066 = cljs.core.vec.call(null,chs);
var inst_12067 = inst_12066;
var state_12097__$1 = (function (){var statearr_12102 = state_12097;
(statearr_12102[(10)] = inst_12067);

return statearr_12102;
})();
var statearr_12103_12128 = state_12097__$1;
(statearr_12103_12128[(2)] = null);

(statearr_12103_12128[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (4))){
var inst_12067 = (state_12097[(10)]);
var state_12097__$1 = state_12097;
return cljs.core.async.ioc_alts_BANG_.call(null,state_12097__$1,(7),inst_12067);
} else {
if((state_val_12098 === (6))){
var inst_12093 = (state_12097[(2)]);
var state_12097__$1 = state_12097;
var statearr_12104_12129 = state_12097__$1;
(statearr_12104_12129[(2)] = inst_12093);

(statearr_12104_12129[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (3))){
var inst_12095 = (state_12097[(2)]);
var state_12097__$1 = state_12097;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12097__$1,inst_12095);
} else {
if((state_val_12098 === (2))){
var inst_12067 = (state_12097[(10)]);
var inst_12069 = cljs.core.count.call(null,inst_12067);
var inst_12070 = (inst_12069 > (0));
var state_12097__$1 = state_12097;
if(cljs.core.truth_(inst_12070)){
var statearr_12106_12130 = state_12097__$1;
(statearr_12106_12130[(1)] = (4));

} else {
var statearr_12107_12131 = state_12097__$1;
(statearr_12107_12131[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (11))){
var inst_12067 = (state_12097[(10)]);
var inst_12086 = (state_12097[(2)]);
var tmp12105 = inst_12067;
var inst_12067__$1 = tmp12105;
var state_12097__$1 = (function (){var statearr_12108 = state_12097;
(statearr_12108[(10)] = inst_12067__$1);

(statearr_12108[(11)] = inst_12086);

return statearr_12108;
})();
var statearr_12109_12132 = state_12097__$1;
(statearr_12109_12132[(2)] = null);

(statearr_12109_12132[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (9))){
var inst_12077 = (state_12097[(7)]);
var state_12097__$1 = state_12097;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12097__$1,(11),out,inst_12077);
} else {
if((state_val_12098 === (5))){
var inst_12091 = cljs.core.async.close_BANG_.call(null,out);
var state_12097__$1 = state_12097;
var statearr_12110_12133 = state_12097__$1;
(statearr_12110_12133[(2)] = inst_12091);

(statearr_12110_12133[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (10))){
var inst_12089 = (state_12097[(2)]);
var state_12097__$1 = state_12097;
var statearr_12111_12134 = state_12097__$1;
(statearr_12111_12134[(2)] = inst_12089);

(statearr_12111_12134[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12098 === (8))){
var inst_12067 = (state_12097[(10)]);
var inst_12077 = (state_12097[(7)]);
var inst_12076 = (state_12097[(8)]);
var inst_12078 = (state_12097[(9)]);
var inst_12081 = (function (){var cs = inst_12067;
var vec__12072 = inst_12076;
var v = inst_12077;
var c = inst_12078;
return ((function (cs,vec__12072,v,c,inst_12067,inst_12077,inst_12076,inst_12078,state_val_12098,c__9975__auto___12125,out){
return (function (p1__12062_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__12062_SHARP_);
});
;})(cs,vec__12072,v,c,inst_12067,inst_12077,inst_12076,inst_12078,state_val_12098,c__9975__auto___12125,out))
})();
var inst_12082 = cljs.core.filterv.call(null,inst_12081,inst_12067);
var inst_12067__$1 = inst_12082;
var state_12097__$1 = (function (){var statearr_12112 = state_12097;
(statearr_12112[(10)] = inst_12067__$1);

return statearr_12112;
})();
var statearr_12113_12135 = state_12097__$1;
(statearr_12113_12135[(2)] = null);

(statearr_12113_12135[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12125,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12125,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12117 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12117[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12117[(1)] = (1));

return statearr_12117;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12097){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12097);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12118){if((e12118 instanceof Object)){
var ex__8772__auto__ = e12118;
var statearr_12119_12136 = state_12097;
(statearr_12119_12136[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12097);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12118;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12137 = state_12097;
state_12097 = G__12137;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12097){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12097);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12125,out))
})();
var state__9977__auto__ = (function (){var statearr_12120 = f__9976__auto__.call(null);
(statearr_12120[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12125);

return statearr_12120;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12125,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args12138 = [];
var len__7484__auto___12187 = arguments.length;
var i__7485__auto___12188 = (0);
while(true){
if((i__7485__auto___12188 < len__7484__auto___12187)){
args12138.push((arguments[i__7485__auto___12188]));

var G__12189 = (i__7485__auto___12188 + (1));
i__7485__auto___12188 = G__12189;
continue;
} else {
}
break;
}

var G__12140 = args12138.length;
switch (G__12140) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12138.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12191 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12191,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12191,out){
return (function (state_12164){
var state_val_12165 = (state_12164[(1)]);
if((state_val_12165 === (7))){
var inst_12146 = (state_12164[(7)]);
var inst_12146__$1 = (state_12164[(2)]);
var inst_12147 = (inst_12146__$1 == null);
var inst_12148 = cljs.core.not.call(null,inst_12147);
var state_12164__$1 = (function (){var statearr_12166 = state_12164;
(statearr_12166[(7)] = inst_12146__$1);

return statearr_12166;
})();
if(inst_12148){
var statearr_12167_12192 = state_12164__$1;
(statearr_12167_12192[(1)] = (8));

} else {
var statearr_12168_12193 = state_12164__$1;
(statearr_12168_12193[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (1))){
var inst_12141 = (0);
var state_12164__$1 = (function (){var statearr_12169 = state_12164;
(statearr_12169[(8)] = inst_12141);

return statearr_12169;
})();
var statearr_12170_12194 = state_12164__$1;
(statearr_12170_12194[(2)] = null);

(statearr_12170_12194[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (4))){
var state_12164__$1 = state_12164;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12164__$1,(7),ch);
} else {
if((state_val_12165 === (6))){
var inst_12159 = (state_12164[(2)]);
var state_12164__$1 = state_12164;
var statearr_12171_12195 = state_12164__$1;
(statearr_12171_12195[(2)] = inst_12159);

(statearr_12171_12195[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (3))){
var inst_12161 = (state_12164[(2)]);
var inst_12162 = cljs.core.async.close_BANG_.call(null,out);
var state_12164__$1 = (function (){var statearr_12172 = state_12164;
(statearr_12172[(9)] = inst_12161);

return statearr_12172;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12164__$1,inst_12162);
} else {
if((state_val_12165 === (2))){
var inst_12141 = (state_12164[(8)]);
var inst_12143 = (inst_12141 < n);
var state_12164__$1 = state_12164;
if(cljs.core.truth_(inst_12143)){
var statearr_12173_12196 = state_12164__$1;
(statearr_12173_12196[(1)] = (4));

} else {
var statearr_12174_12197 = state_12164__$1;
(statearr_12174_12197[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (11))){
var inst_12141 = (state_12164[(8)]);
var inst_12151 = (state_12164[(2)]);
var inst_12152 = (inst_12141 + (1));
var inst_12141__$1 = inst_12152;
var state_12164__$1 = (function (){var statearr_12175 = state_12164;
(statearr_12175[(8)] = inst_12141__$1);

(statearr_12175[(10)] = inst_12151);

return statearr_12175;
})();
var statearr_12176_12198 = state_12164__$1;
(statearr_12176_12198[(2)] = null);

(statearr_12176_12198[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (9))){
var state_12164__$1 = state_12164;
var statearr_12177_12199 = state_12164__$1;
(statearr_12177_12199[(2)] = null);

(statearr_12177_12199[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (5))){
var state_12164__$1 = state_12164;
var statearr_12178_12200 = state_12164__$1;
(statearr_12178_12200[(2)] = null);

(statearr_12178_12200[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (10))){
var inst_12156 = (state_12164[(2)]);
var state_12164__$1 = state_12164;
var statearr_12179_12201 = state_12164__$1;
(statearr_12179_12201[(2)] = inst_12156);

(statearr_12179_12201[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12165 === (8))){
var inst_12146 = (state_12164[(7)]);
var state_12164__$1 = state_12164;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12164__$1,(11),out,inst_12146);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12191,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12191,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12183 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_12183[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12183[(1)] = (1));

return statearr_12183;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12164){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12164);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12184){if((e12184 instanceof Object)){
var ex__8772__auto__ = e12184;
var statearr_12185_12202 = state_12164;
(statearr_12185_12202[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12164);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12184;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12203 = state_12164;
state_12164 = G__12203;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12164){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12164);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12191,out))
})();
var state__9977__auto__ = (function (){var statearr_12186 = f__9976__auto__.call(null);
(statearr_12186[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12191);

return statearr_12186;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12191,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async12211 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async12211 = (function (map_LT_,f,ch,meta12212){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta12212 = meta12212;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_12213,meta12212__$1){
var self__ = this;
var _12213__$1 = this;
return (new cljs.core.async.t_cljs$core$async12211(self__.map_LT_,self__.f,self__.ch,meta12212__$1));
});

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_12213){
var self__ = this;
var _12213__$1 = this;
return self__.meta12212;
});

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async12214 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async12214 = (function (map_LT_,f,ch,meta12212,_,fn1,meta12215){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta12212 = meta12212;
this._ = _;
this.fn1 = fn1;
this.meta12215 = meta12215;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_12216,meta12215__$1){
var self__ = this;
var _12216__$1 = this;
return (new cljs.core.async.t_cljs$core$async12214(self__.map_LT_,self__.f,self__.ch,self__.meta12212,self__._,self__.fn1,meta12215__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_12216){
var self__ = this;
var _12216__$1 = this;
return self__.meta12215;
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__12204_SHARP_){
return f1.call(null,(((p1__12204_SHARP_ == null))?null:self__.f.call(null,p1__12204_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta12212","meta12212",1798241139,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async12211","cljs.core.async/t_cljs$core$async12211",-1304341997,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta12215","meta12215",1955556858,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async12214.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async12214.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async12214";

cljs.core.async.t_cljs$core$async12214.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async12214");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async12214 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async12214(map_LT___$1,f__$1,ch__$1,meta12212__$1,___$2,fn1__$1,meta12215){
return (new cljs.core.async.t_cljs$core$async12214(map_LT___$1,f__$1,ch__$1,meta12212__$1,___$2,fn1__$1,meta12215));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async12214(self__.map_LT_,self__.f,self__.ch,self__.meta12212,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__6397__auto__ = ret;
if(cljs.core.truth_(and__6397__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__6397__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async12211.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async12211.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta12212","meta12212",1798241139,null)], null);
});

cljs.core.async.t_cljs$core$async12211.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async12211.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async12211";

cljs.core.async.t_cljs$core$async12211.cljs$lang$ctorPrWriter = (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async12211");
});

cljs.core.async.__GT_t_cljs$core$async12211 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async12211(map_LT___$1,f__$1,ch__$1,meta12212){
return (new cljs.core.async.t_cljs$core$async12211(map_LT___$1,f__$1,ch__$1,meta12212));
});

}

return (new cljs.core.async.t_cljs$core$async12211(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async12220 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async12220 = (function (map_GT_,f,ch,meta12221){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta12221 = meta12221;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_12222,meta12221__$1){
var self__ = this;
var _12222__$1 = this;
return (new cljs.core.async.t_cljs$core$async12220(self__.map_GT_,self__.f,self__.ch,meta12221__$1));
});

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_12222){
var self__ = this;
var _12222__$1 = this;
return self__.meta12221;
});

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async12220.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async12220.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map>","map>",1676369295,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta12221","meta12221",1373572864,null)], null);
});

cljs.core.async.t_cljs$core$async12220.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async12220.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async12220";

cljs.core.async.t_cljs$core$async12220.cljs$lang$ctorPrWriter = (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async12220");
});

cljs.core.async.__GT_t_cljs$core$async12220 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async12220(map_GT___$1,f__$1,ch__$1,meta12221){
return (new cljs.core.async.t_cljs$core$async12220(map_GT___$1,f__$1,ch__$1,meta12221));
});

}

return (new cljs.core.async.t_cljs$core$async12220(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async12226 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async12226 = (function (filter_GT_,p,ch,meta12227){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta12227 = meta12227;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_12228,meta12227__$1){
var self__ = this;
var _12228__$1 = this;
return (new cljs.core.async.t_cljs$core$async12226(self__.filter_GT_,self__.p,self__.ch,meta12227__$1));
});

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_12228){
var self__ = this;
var _12228__$1 = this;
return self__.meta12227;
});

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async12226.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async12226.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"filter>","filter>",-37644455,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta12227","meta12227",1083223127,null)], null);
});

cljs.core.async.t_cljs$core$async12226.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async12226.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async12226";

cljs.core.async.t_cljs$core$async12226.cljs$lang$ctorPrWriter = (function (this__7015__auto__,writer__7016__auto__,opt__7017__auto__){
return cljs.core._write.call(null,writer__7016__auto__,"cljs.core.async/t_cljs$core$async12226");
});

cljs.core.async.__GT_t_cljs$core$async12226 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async12226(filter_GT___$1,p__$1,ch__$1,meta12227){
return (new cljs.core.async.t_cljs$core$async12226(filter_GT___$1,p__$1,ch__$1,meta12227));
});

}

return (new cljs.core.async.t_cljs$core$async12226(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args12229 = [];
var len__7484__auto___12273 = arguments.length;
var i__7485__auto___12274 = (0);
while(true){
if((i__7485__auto___12274 < len__7484__auto___12273)){
args12229.push((arguments[i__7485__auto___12274]));

var G__12275 = (i__7485__auto___12274 + (1));
i__7485__auto___12274 = G__12275;
continue;
} else {
}
break;
}

var G__12231 = args12229.length;
switch (G__12231) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12229.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12277 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12277,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12277,out){
return (function (state_12252){
var state_val_12253 = (state_12252[(1)]);
if((state_val_12253 === (7))){
var inst_12248 = (state_12252[(2)]);
var state_12252__$1 = state_12252;
var statearr_12254_12278 = state_12252__$1;
(statearr_12254_12278[(2)] = inst_12248);

(statearr_12254_12278[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (1))){
var state_12252__$1 = state_12252;
var statearr_12255_12279 = state_12252__$1;
(statearr_12255_12279[(2)] = null);

(statearr_12255_12279[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (4))){
var inst_12234 = (state_12252[(7)]);
var inst_12234__$1 = (state_12252[(2)]);
var inst_12235 = (inst_12234__$1 == null);
var state_12252__$1 = (function (){var statearr_12256 = state_12252;
(statearr_12256[(7)] = inst_12234__$1);

return statearr_12256;
})();
if(cljs.core.truth_(inst_12235)){
var statearr_12257_12280 = state_12252__$1;
(statearr_12257_12280[(1)] = (5));

} else {
var statearr_12258_12281 = state_12252__$1;
(statearr_12258_12281[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (6))){
var inst_12234 = (state_12252[(7)]);
var inst_12239 = p.call(null,inst_12234);
var state_12252__$1 = state_12252;
if(cljs.core.truth_(inst_12239)){
var statearr_12259_12282 = state_12252__$1;
(statearr_12259_12282[(1)] = (8));

} else {
var statearr_12260_12283 = state_12252__$1;
(statearr_12260_12283[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (3))){
var inst_12250 = (state_12252[(2)]);
var state_12252__$1 = state_12252;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12252__$1,inst_12250);
} else {
if((state_val_12253 === (2))){
var state_12252__$1 = state_12252;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12252__$1,(4),ch);
} else {
if((state_val_12253 === (11))){
var inst_12242 = (state_12252[(2)]);
var state_12252__$1 = state_12252;
var statearr_12261_12284 = state_12252__$1;
(statearr_12261_12284[(2)] = inst_12242);

(statearr_12261_12284[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (9))){
var state_12252__$1 = state_12252;
var statearr_12262_12285 = state_12252__$1;
(statearr_12262_12285[(2)] = null);

(statearr_12262_12285[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (5))){
var inst_12237 = cljs.core.async.close_BANG_.call(null,out);
var state_12252__$1 = state_12252;
var statearr_12263_12286 = state_12252__$1;
(statearr_12263_12286[(2)] = inst_12237);

(statearr_12263_12286[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (10))){
var inst_12245 = (state_12252[(2)]);
var state_12252__$1 = (function (){var statearr_12264 = state_12252;
(statearr_12264[(8)] = inst_12245);

return statearr_12264;
})();
var statearr_12265_12287 = state_12252__$1;
(statearr_12265_12287[(2)] = null);

(statearr_12265_12287[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12253 === (8))){
var inst_12234 = (state_12252[(7)]);
var state_12252__$1 = state_12252;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12252__$1,(11),out,inst_12234);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12277,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12277,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12269 = [null,null,null,null,null,null,null,null,null];
(statearr_12269[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12269[(1)] = (1));

return statearr_12269;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12252){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12252);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12270){if((e12270 instanceof Object)){
var ex__8772__auto__ = e12270;
var statearr_12271_12288 = state_12252;
(statearr_12271_12288[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12252);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12270;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12289 = state_12252;
state_12252 = G__12289;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12252){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12252);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12277,out))
})();
var state__9977__auto__ = (function (){var statearr_12272 = f__9976__auto__.call(null);
(statearr_12272[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12277);

return statearr_12272;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12277,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args12290 = [];
var len__7484__auto___12293 = arguments.length;
var i__7485__auto___12294 = (0);
while(true){
if((i__7485__auto___12294 < len__7484__auto___12293)){
args12290.push((arguments[i__7485__auto___12294]));

var G__12295 = (i__7485__auto___12294 + (1));
i__7485__auto___12294 = G__12295;
continue;
} else {
}
break;
}

var G__12292 = args12290.length;
switch (G__12292) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12290.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__){
return (function (state_12462){
var state_val_12463 = (state_12462[(1)]);
if((state_val_12463 === (7))){
var inst_12458 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
var statearr_12464_12505 = state_12462__$1;
(statearr_12464_12505[(2)] = inst_12458);

(statearr_12464_12505[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (20))){
var inst_12428 = (state_12462[(7)]);
var inst_12439 = (state_12462[(2)]);
var inst_12440 = cljs.core.next.call(null,inst_12428);
var inst_12414 = inst_12440;
var inst_12415 = null;
var inst_12416 = (0);
var inst_12417 = (0);
var state_12462__$1 = (function (){var statearr_12465 = state_12462;
(statearr_12465[(8)] = inst_12417);

(statearr_12465[(9)] = inst_12415);

(statearr_12465[(10)] = inst_12416);

(statearr_12465[(11)] = inst_12439);

(statearr_12465[(12)] = inst_12414);

return statearr_12465;
})();
var statearr_12466_12506 = state_12462__$1;
(statearr_12466_12506[(2)] = null);

(statearr_12466_12506[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (1))){
var state_12462__$1 = state_12462;
var statearr_12467_12507 = state_12462__$1;
(statearr_12467_12507[(2)] = null);

(statearr_12467_12507[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (4))){
var inst_12403 = (state_12462[(13)]);
var inst_12403__$1 = (state_12462[(2)]);
var inst_12404 = (inst_12403__$1 == null);
var state_12462__$1 = (function (){var statearr_12468 = state_12462;
(statearr_12468[(13)] = inst_12403__$1);

return statearr_12468;
})();
if(cljs.core.truth_(inst_12404)){
var statearr_12469_12508 = state_12462__$1;
(statearr_12469_12508[(1)] = (5));

} else {
var statearr_12470_12509 = state_12462__$1;
(statearr_12470_12509[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (15))){
var state_12462__$1 = state_12462;
var statearr_12474_12510 = state_12462__$1;
(statearr_12474_12510[(2)] = null);

(statearr_12474_12510[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (21))){
var state_12462__$1 = state_12462;
var statearr_12475_12511 = state_12462__$1;
(statearr_12475_12511[(2)] = null);

(statearr_12475_12511[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (13))){
var inst_12417 = (state_12462[(8)]);
var inst_12415 = (state_12462[(9)]);
var inst_12416 = (state_12462[(10)]);
var inst_12414 = (state_12462[(12)]);
var inst_12424 = (state_12462[(2)]);
var inst_12425 = (inst_12417 + (1));
var tmp12471 = inst_12415;
var tmp12472 = inst_12416;
var tmp12473 = inst_12414;
var inst_12414__$1 = tmp12473;
var inst_12415__$1 = tmp12471;
var inst_12416__$1 = tmp12472;
var inst_12417__$1 = inst_12425;
var state_12462__$1 = (function (){var statearr_12476 = state_12462;
(statearr_12476[(8)] = inst_12417__$1);

(statearr_12476[(9)] = inst_12415__$1);

(statearr_12476[(10)] = inst_12416__$1);

(statearr_12476[(14)] = inst_12424);

(statearr_12476[(12)] = inst_12414__$1);

return statearr_12476;
})();
var statearr_12477_12512 = state_12462__$1;
(statearr_12477_12512[(2)] = null);

(statearr_12477_12512[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (22))){
var state_12462__$1 = state_12462;
var statearr_12478_12513 = state_12462__$1;
(statearr_12478_12513[(2)] = null);

(statearr_12478_12513[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (6))){
var inst_12403 = (state_12462[(13)]);
var inst_12412 = f.call(null,inst_12403);
var inst_12413 = cljs.core.seq.call(null,inst_12412);
var inst_12414 = inst_12413;
var inst_12415 = null;
var inst_12416 = (0);
var inst_12417 = (0);
var state_12462__$1 = (function (){var statearr_12479 = state_12462;
(statearr_12479[(8)] = inst_12417);

(statearr_12479[(9)] = inst_12415);

(statearr_12479[(10)] = inst_12416);

(statearr_12479[(12)] = inst_12414);

return statearr_12479;
})();
var statearr_12480_12514 = state_12462__$1;
(statearr_12480_12514[(2)] = null);

(statearr_12480_12514[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (17))){
var inst_12428 = (state_12462[(7)]);
var inst_12432 = cljs.core.chunk_first.call(null,inst_12428);
var inst_12433 = cljs.core.chunk_rest.call(null,inst_12428);
var inst_12434 = cljs.core.count.call(null,inst_12432);
var inst_12414 = inst_12433;
var inst_12415 = inst_12432;
var inst_12416 = inst_12434;
var inst_12417 = (0);
var state_12462__$1 = (function (){var statearr_12481 = state_12462;
(statearr_12481[(8)] = inst_12417);

(statearr_12481[(9)] = inst_12415);

(statearr_12481[(10)] = inst_12416);

(statearr_12481[(12)] = inst_12414);

return statearr_12481;
})();
var statearr_12482_12515 = state_12462__$1;
(statearr_12482_12515[(2)] = null);

(statearr_12482_12515[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (3))){
var inst_12460 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12462__$1,inst_12460);
} else {
if((state_val_12463 === (12))){
var inst_12448 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
var statearr_12483_12516 = state_12462__$1;
(statearr_12483_12516[(2)] = inst_12448);

(statearr_12483_12516[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (2))){
var state_12462__$1 = state_12462;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12462__$1,(4),in$);
} else {
if((state_val_12463 === (23))){
var inst_12456 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
var statearr_12484_12517 = state_12462__$1;
(statearr_12484_12517[(2)] = inst_12456);

(statearr_12484_12517[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (19))){
var inst_12443 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
var statearr_12485_12518 = state_12462__$1;
(statearr_12485_12518[(2)] = inst_12443);

(statearr_12485_12518[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (11))){
var inst_12428 = (state_12462[(7)]);
var inst_12414 = (state_12462[(12)]);
var inst_12428__$1 = cljs.core.seq.call(null,inst_12414);
var state_12462__$1 = (function (){var statearr_12486 = state_12462;
(statearr_12486[(7)] = inst_12428__$1);

return statearr_12486;
})();
if(inst_12428__$1){
var statearr_12487_12519 = state_12462__$1;
(statearr_12487_12519[(1)] = (14));

} else {
var statearr_12488_12520 = state_12462__$1;
(statearr_12488_12520[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (9))){
var inst_12450 = (state_12462[(2)]);
var inst_12451 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_12462__$1 = (function (){var statearr_12489 = state_12462;
(statearr_12489[(15)] = inst_12450);

return statearr_12489;
})();
if(cljs.core.truth_(inst_12451)){
var statearr_12490_12521 = state_12462__$1;
(statearr_12490_12521[(1)] = (21));

} else {
var statearr_12491_12522 = state_12462__$1;
(statearr_12491_12522[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (5))){
var inst_12406 = cljs.core.async.close_BANG_.call(null,out);
var state_12462__$1 = state_12462;
var statearr_12492_12523 = state_12462__$1;
(statearr_12492_12523[(2)] = inst_12406);

(statearr_12492_12523[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (14))){
var inst_12428 = (state_12462[(7)]);
var inst_12430 = cljs.core.chunked_seq_QMARK_.call(null,inst_12428);
var state_12462__$1 = state_12462;
if(inst_12430){
var statearr_12493_12524 = state_12462__$1;
(statearr_12493_12524[(1)] = (17));

} else {
var statearr_12494_12525 = state_12462__$1;
(statearr_12494_12525[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (16))){
var inst_12446 = (state_12462[(2)]);
var state_12462__$1 = state_12462;
var statearr_12495_12526 = state_12462__$1;
(statearr_12495_12526[(2)] = inst_12446);

(statearr_12495_12526[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12463 === (10))){
var inst_12417 = (state_12462[(8)]);
var inst_12415 = (state_12462[(9)]);
var inst_12422 = cljs.core._nth.call(null,inst_12415,inst_12417);
var state_12462__$1 = state_12462;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12462__$1,(13),out,inst_12422);
} else {
if((state_val_12463 === (18))){
var inst_12428 = (state_12462[(7)]);
var inst_12437 = cljs.core.first.call(null,inst_12428);
var state_12462__$1 = state_12462;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12462__$1,(20),out,inst_12437);
} else {
if((state_val_12463 === (8))){
var inst_12417 = (state_12462[(8)]);
var inst_12416 = (state_12462[(10)]);
var inst_12419 = (inst_12417 < inst_12416);
var inst_12420 = inst_12419;
var state_12462__$1 = state_12462;
if(cljs.core.truth_(inst_12420)){
var statearr_12496_12527 = state_12462__$1;
(statearr_12496_12527[(1)] = (10));

} else {
var statearr_12497_12528 = state_12462__$1;
(statearr_12497_12528[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto__))
;
return ((function (switch__8768__auto__,c__9975__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____0 = (function (){
var statearr_12501 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12501[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__);

(statearr_12501[(1)] = (1));

return statearr_12501;
});
var cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____1 = (function (state_12462){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12462);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12502){if((e12502 instanceof Object)){
var ex__8772__auto__ = e12502;
var statearr_12503_12529 = state_12462;
(statearr_12503_12529[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12462);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12502;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12530 = state_12462;
state_12462 = G__12530;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__ = function(state_12462){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____1.call(this,state_12462);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__8769__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__))
})();
var state__9977__auto__ = (function (){var statearr_12504 = f__9976__auto__.call(null);
(statearr_12504[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_12504;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__))
);

return c__9975__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args12531 = [];
var len__7484__auto___12534 = arguments.length;
var i__7485__auto___12535 = (0);
while(true){
if((i__7485__auto___12535 < len__7484__auto___12534)){
args12531.push((arguments[i__7485__auto___12535]));

var G__12536 = (i__7485__auto___12535 + (1));
i__7485__auto___12535 = G__12536;
continue;
} else {
}
break;
}

var G__12533 = args12531.length;
switch (G__12533) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12531.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args12538 = [];
var len__7484__auto___12541 = arguments.length;
var i__7485__auto___12542 = (0);
while(true){
if((i__7485__auto___12542 < len__7484__auto___12541)){
args12538.push((arguments[i__7485__auto___12542]));

var G__12543 = (i__7485__auto___12542 + (1));
i__7485__auto___12542 = G__12543;
continue;
} else {
}
break;
}

var G__12540 = args12538.length;
switch (G__12540) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12538.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args12545 = [];
var len__7484__auto___12596 = arguments.length;
var i__7485__auto___12597 = (0);
while(true){
if((i__7485__auto___12597 < len__7484__auto___12596)){
args12545.push((arguments[i__7485__auto___12597]));

var G__12598 = (i__7485__auto___12597 + (1));
i__7485__auto___12597 = G__12598;
continue;
} else {
}
break;
}

var G__12547 = args12545.length;
switch (G__12547) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12545.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12600 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12600,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12600,out){
return (function (state_12571){
var state_val_12572 = (state_12571[(1)]);
if((state_val_12572 === (7))){
var inst_12566 = (state_12571[(2)]);
var state_12571__$1 = state_12571;
var statearr_12573_12601 = state_12571__$1;
(statearr_12573_12601[(2)] = inst_12566);

(statearr_12573_12601[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (1))){
var inst_12548 = null;
var state_12571__$1 = (function (){var statearr_12574 = state_12571;
(statearr_12574[(7)] = inst_12548);

return statearr_12574;
})();
var statearr_12575_12602 = state_12571__$1;
(statearr_12575_12602[(2)] = null);

(statearr_12575_12602[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (4))){
var inst_12551 = (state_12571[(8)]);
var inst_12551__$1 = (state_12571[(2)]);
var inst_12552 = (inst_12551__$1 == null);
var inst_12553 = cljs.core.not.call(null,inst_12552);
var state_12571__$1 = (function (){var statearr_12576 = state_12571;
(statearr_12576[(8)] = inst_12551__$1);

return statearr_12576;
})();
if(inst_12553){
var statearr_12577_12603 = state_12571__$1;
(statearr_12577_12603[(1)] = (5));

} else {
var statearr_12578_12604 = state_12571__$1;
(statearr_12578_12604[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (6))){
var state_12571__$1 = state_12571;
var statearr_12579_12605 = state_12571__$1;
(statearr_12579_12605[(2)] = null);

(statearr_12579_12605[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (3))){
var inst_12568 = (state_12571[(2)]);
var inst_12569 = cljs.core.async.close_BANG_.call(null,out);
var state_12571__$1 = (function (){var statearr_12580 = state_12571;
(statearr_12580[(9)] = inst_12568);

return statearr_12580;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12571__$1,inst_12569);
} else {
if((state_val_12572 === (2))){
var state_12571__$1 = state_12571;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12571__$1,(4),ch);
} else {
if((state_val_12572 === (11))){
var inst_12551 = (state_12571[(8)]);
var inst_12560 = (state_12571[(2)]);
var inst_12548 = inst_12551;
var state_12571__$1 = (function (){var statearr_12581 = state_12571;
(statearr_12581[(7)] = inst_12548);

(statearr_12581[(10)] = inst_12560);

return statearr_12581;
})();
var statearr_12582_12606 = state_12571__$1;
(statearr_12582_12606[(2)] = null);

(statearr_12582_12606[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (9))){
var inst_12551 = (state_12571[(8)]);
var state_12571__$1 = state_12571;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12571__$1,(11),out,inst_12551);
} else {
if((state_val_12572 === (5))){
var inst_12551 = (state_12571[(8)]);
var inst_12548 = (state_12571[(7)]);
var inst_12555 = cljs.core._EQ_.call(null,inst_12551,inst_12548);
var state_12571__$1 = state_12571;
if(inst_12555){
var statearr_12584_12607 = state_12571__$1;
(statearr_12584_12607[(1)] = (8));

} else {
var statearr_12585_12608 = state_12571__$1;
(statearr_12585_12608[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (10))){
var inst_12563 = (state_12571[(2)]);
var state_12571__$1 = state_12571;
var statearr_12586_12609 = state_12571__$1;
(statearr_12586_12609[(2)] = inst_12563);

(statearr_12586_12609[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12572 === (8))){
var inst_12548 = (state_12571[(7)]);
var tmp12583 = inst_12548;
var inst_12548__$1 = tmp12583;
var state_12571__$1 = (function (){var statearr_12587 = state_12571;
(statearr_12587[(7)] = inst_12548__$1);

return statearr_12587;
})();
var statearr_12588_12610 = state_12571__$1;
(statearr_12588_12610[(2)] = null);

(statearr_12588_12610[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12600,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12600,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12592 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_12592[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12592[(1)] = (1));

return statearr_12592;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12571){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12571);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12593){if((e12593 instanceof Object)){
var ex__8772__auto__ = e12593;
var statearr_12594_12611 = state_12571;
(statearr_12594_12611[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12571);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12593;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12612 = state_12571;
state_12571 = G__12612;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12571){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12571);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12600,out))
})();
var state__9977__auto__ = (function (){var statearr_12595 = f__9976__auto__.call(null);
(statearr_12595[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12600);

return statearr_12595;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12600,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args12613 = [];
var len__7484__auto___12683 = arguments.length;
var i__7485__auto___12684 = (0);
while(true){
if((i__7485__auto___12684 < len__7484__auto___12683)){
args12613.push((arguments[i__7485__auto___12684]));

var G__12685 = (i__7485__auto___12684 + (1));
i__7485__auto___12684 = G__12685;
continue;
} else {
}
break;
}

var G__12615 = args12613.length;
switch (G__12615) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12613.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12687 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12687,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12687,out){
return (function (state_12653){
var state_val_12654 = (state_12653[(1)]);
if((state_val_12654 === (7))){
var inst_12649 = (state_12653[(2)]);
var state_12653__$1 = state_12653;
var statearr_12655_12688 = state_12653__$1;
(statearr_12655_12688[(2)] = inst_12649);

(statearr_12655_12688[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (1))){
var inst_12616 = (new Array(n));
var inst_12617 = inst_12616;
var inst_12618 = (0);
var state_12653__$1 = (function (){var statearr_12656 = state_12653;
(statearr_12656[(7)] = inst_12617);

(statearr_12656[(8)] = inst_12618);

return statearr_12656;
})();
var statearr_12657_12689 = state_12653__$1;
(statearr_12657_12689[(2)] = null);

(statearr_12657_12689[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (4))){
var inst_12621 = (state_12653[(9)]);
var inst_12621__$1 = (state_12653[(2)]);
var inst_12622 = (inst_12621__$1 == null);
var inst_12623 = cljs.core.not.call(null,inst_12622);
var state_12653__$1 = (function (){var statearr_12658 = state_12653;
(statearr_12658[(9)] = inst_12621__$1);

return statearr_12658;
})();
if(inst_12623){
var statearr_12659_12690 = state_12653__$1;
(statearr_12659_12690[(1)] = (5));

} else {
var statearr_12660_12691 = state_12653__$1;
(statearr_12660_12691[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (15))){
var inst_12643 = (state_12653[(2)]);
var state_12653__$1 = state_12653;
var statearr_12661_12692 = state_12653__$1;
(statearr_12661_12692[(2)] = inst_12643);

(statearr_12661_12692[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (13))){
var state_12653__$1 = state_12653;
var statearr_12662_12693 = state_12653__$1;
(statearr_12662_12693[(2)] = null);

(statearr_12662_12693[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (6))){
var inst_12618 = (state_12653[(8)]);
var inst_12639 = (inst_12618 > (0));
var state_12653__$1 = state_12653;
if(cljs.core.truth_(inst_12639)){
var statearr_12663_12694 = state_12653__$1;
(statearr_12663_12694[(1)] = (12));

} else {
var statearr_12664_12695 = state_12653__$1;
(statearr_12664_12695[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (3))){
var inst_12651 = (state_12653[(2)]);
var state_12653__$1 = state_12653;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12653__$1,inst_12651);
} else {
if((state_val_12654 === (12))){
var inst_12617 = (state_12653[(7)]);
var inst_12641 = cljs.core.vec.call(null,inst_12617);
var state_12653__$1 = state_12653;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12653__$1,(15),out,inst_12641);
} else {
if((state_val_12654 === (2))){
var state_12653__$1 = state_12653;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12653__$1,(4),ch);
} else {
if((state_val_12654 === (11))){
var inst_12633 = (state_12653[(2)]);
var inst_12634 = (new Array(n));
var inst_12617 = inst_12634;
var inst_12618 = (0);
var state_12653__$1 = (function (){var statearr_12665 = state_12653;
(statearr_12665[(7)] = inst_12617);

(statearr_12665[(10)] = inst_12633);

(statearr_12665[(8)] = inst_12618);

return statearr_12665;
})();
var statearr_12666_12696 = state_12653__$1;
(statearr_12666_12696[(2)] = null);

(statearr_12666_12696[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (9))){
var inst_12617 = (state_12653[(7)]);
var inst_12631 = cljs.core.vec.call(null,inst_12617);
var state_12653__$1 = state_12653;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12653__$1,(11),out,inst_12631);
} else {
if((state_val_12654 === (5))){
var inst_12617 = (state_12653[(7)]);
var inst_12621 = (state_12653[(9)]);
var inst_12626 = (state_12653[(11)]);
var inst_12618 = (state_12653[(8)]);
var inst_12625 = (inst_12617[inst_12618] = inst_12621);
var inst_12626__$1 = (inst_12618 + (1));
var inst_12627 = (inst_12626__$1 < n);
var state_12653__$1 = (function (){var statearr_12667 = state_12653;
(statearr_12667[(12)] = inst_12625);

(statearr_12667[(11)] = inst_12626__$1);

return statearr_12667;
})();
if(cljs.core.truth_(inst_12627)){
var statearr_12668_12697 = state_12653__$1;
(statearr_12668_12697[(1)] = (8));

} else {
var statearr_12669_12698 = state_12653__$1;
(statearr_12669_12698[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (14))){
var inst_12646 = (state_12653[(2)]);
var inst_12647 = cljs.core.async.close_BANG_.call(null,out);
var state_12653__$1 = (function (){var statearr_12671 = state_12653;
(statearr_12671[(13)] = inst_12646);

return statearr_12671;
})();
var statearr_12672_12699 = state_12653__$1;
(statearr_12672_12699[(2)] = inst_12647);

(statearr_12672_12699[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (10))){
var inst_12637 = (state_12653[(2)]);
var state_12653__$1 = state_12653;
var statearr_12673_12700 = state_12653__$1;
(statearr_12673_12700[(2)] = inst_12637);

(statearr_12673_12700[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12654 === (8))){
var inst_12617 = (state_12653[(7)]);
var inst_12626 = (state_12653[(11)]);
var tmp12670 = inst_12617;
var inst_12617__$1 = tmp12670;
var inst_12618 = inst_12626;
var state_12653__$1 = (function (){var statearr_12674 = state_12653;
(statearr_12674[(7)] = inst_12617__$1);

(statearr_12674[(8)] = inst_12618);

return statearr_12674;
})();
var statearr_12675_12701 = state_12653__$1;
(statearr_12675_12701[(2)] = null);

(statearr_12675_12701[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12687,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12687,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12679 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12679[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12679[(1)] = (1));

return statearr_12679;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12653){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12653);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12680){if((e12680 instanceof Object)){
var ex__8772__auto__ = e12680;
var statearr_12681_12702 = state_12653;
(statearr_12681_12702[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12653);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12680;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12703 = state_12653;
state_12653 = G__12703;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12653){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12653);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12687,out))
})();
var state__9977__auto__ = (function (){var statearr_12682 = f__9976__auto__.call(null);
(statearr_12682[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12687);

return statearr_12682;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12687,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args12704 = [];
var len__7484__auto___12778 = arguments.length;
var i__7485__auto___12779 = (0);
while(true){
if((i__7485__auto___12779 < len__7484__auto___12778)){
args12704.push((arguments[i__7485__auto___12779]));

var G__12780 = (i__7485__auto___12779 + (1));
i__7485__auto___12779 = G__12780;
continue;
} else {
}
break;
}

var G__12706 = args12704.length;
switch (G__12706) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12704.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__9975__auto___12782 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___12782,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___12782,out){
return (function (state_12748){
var state_val_12749 = (state_12748[(1)]);
if((state_val_12749 === (7))){
var inst_12744 = (state_12748[(2)]);
var state_12748__$1 = state_12748;
var statearr_12750_12783 = state_12748__$1;
(statearr_12750_12783[(2)] = inst_12744);

(statearr_12750_12783[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (1))){
var inst_12707 = [];
var inst_12708 = inst_12707;
var inst_12709 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_12748__$1 = (function (){var statearr_12751 = state_12748;
(statearr_12751[(7)] = inst_12709);

(statearr_12751[(8)] = inst_12708);

return statearr_12751;
})();
var statearr_12752_12784 = state_12748__$1;
(statearr_12752_12784[(2)] = null);

(statearr_12752_12784[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (4))){
var inst_12712 = (state_12748[(9)]);
var inst_12712__$1 = (state_12748[(2)]);
var inst_12713 = (inst_12712__$1 == null);
var inst_12714 = cljs.core.not.call(null,inst_12713);
var state_12748__$1 = (function (){var statearr_12753 = state_12748;
(statearr_12753[(9)] = inst_12712__$1);

return statearr_12753;
})();
if(inst_12714){
var statearr_12754_12785 = state_12748__$1;
(statearr_12754_12785[(1)] = (5));

} else {
var statearr_12755_12786 = state_12748__$1;
(statearr_12755_12786[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (15))){
var inst_12738 = (state_12748[(2)]);
var state_12748__$1 = state_12748;
var statearr_12756_12787 = state_12748__$1;
(statearr_12756_12787[(2)] = inst_12738);

(statearr_12756_12787[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (13))){
var state_12748__$1 = state_12748;
var statearr_12757_12788 = state_12748__$1;
(statearr_12757_12788[(2)] = null);

(statearr_12757_12788[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (6))){
var inst_12708 = (state_12748[(8)]);
var inst_12733 = inst_12708.length;
var inst_12734 = (inst_12733 > (0));
var state_12748__$1 = state_12748;
if(cljs.core.truth_(inst_12734)){
var statearr_12758_12789 = state_12748__$1;
(statearr_12758_12789[(1)] = (12));

} else {
var statearr_12759_12790 = state_12748__$1;
(statearr_12759_12790[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (3))){
var inst_12746 = (state_12748[(2)]);
var state_12748__$1 = state_12748;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12748__$1,inst_12746);
} else {
if((state_val_12749 === (12))){
var inst_12708 = (state_12748[(8)]);
var inst_12736 = cljs.core.vec.call(null,inst_12708);
var state_12748__$1 = state_12748;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12748__$1,(15),out,inst_12736);
} else {
if((state_val_12749 === (2))){
var state_12748__$1 = state_12748;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12748__$1,(4),ch);
} else {
if((state_val_12749 === (11))){
var inst_12712 = (state_12748[(9)]);
var inst_12716 = (state_12748[(10)]);
var inst_12726 = (state_12748[(2)]);
var inst_12727 = [];
var inst_12728 = inst_12727.push(inst_12712);
var inst_12708 = inst_12727;
var inst_12709 = inst_12716;
var state_12748__$1 = (function (){var statearr_12760 = state_12748;
(statearr_12760[(7)] = inst_12709);

(statearr_12760[(11)] = inst_12728);

(statearr_12760[(12)] = inst_12726);

(statearr_12760[(8)] = inst_12708);

return statearr_12760;
})();
var statearr_12761_12791 = state_12748__$1;
(statearr_12761_12791[(2)] = null);

(statearr_12761_12791[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (9))){
var inst_12708 = (state_12748[(8)]);
var inst_12724 = cljs.core.vec.call(null,inst_12708);
var state_12748__$1 = state_12748;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12748__$1,(11),out,inst_12724);
} else {
if((state_val_12749 === (5))){
var inst_12712 = (state_12748[(9)]);
var inst_12709 = (state_12748[(7)]);
var inst_12716 = (state_12748[(10)]);
var inst_12716__$1 = f.call(null,inst_12712);
var inst_12717 = cljs.core._EQ_.call(null,inst_12716__$1,inst_12709);
var inst_12718 = cljs.core.keyword_identical_QMARK_.call(null,inst_12709,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_12719 = (inst_12717) || (inst_12718);
var state_12748__$1 = (function (){var statearr_12762 = state_12748;
(statearr_12762[(10)] = inst_12716__$1);

return statearr_12762;
})();
if(cljs.core.truth_(inst_12719)){
var statearr_12763_12792 = state_12748__$1;
(statearr_12763_12792[(1)] = (8));

} else {
var statearr_12764_12793 = state_12748__$1;
(statearr_12764_12793[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (14))){
var inst_12741 = (state_12748[(2)]);
var inst_12742 = cljs.core.async.close_BANG_.call(null,out);
var state_12748__$1 = (function (){var statearr_12766 = state_12748;
(statearr_12766[(13)] = inst_12741);

return statearr_12766;
})();
var statearr_12767_12794 = state_12748__$1;
(statearr_12767_12794[(2)] = inst_12742);

(statearr_12767_12794[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (10))){
var inst_12731 = (state_12748[(2)]);
var state_12748__$1 = state_12748;
var statearr_12768_12795 = state_12748__$1;
(statearr_12768_12795[(2)] = inst_12731);

(statearr_12768_12795[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12749 === (8))){
var inst_12712 = (state_12748[(9)]);
var inst_12716 = (state_12748[(10)]);
var inst_12708 = (state_12748[(8)]);
var inst_12721 = inst_12708.push(inst_12712);
var tmp12765 = inst_12708;
var inst_12708__$1 = tmp12765;
var inst_12709 = inst_12716;
var state_12748__$1 = (function (){var statearr_12769 = state_12748;
(statearr_12769[(7)] = inst_12709);

(statearr_12769[(14)] = inst_12721);

(statearr_12769[(8)] = inst_12708__$1);

return statearr_12769;
})();
var statearr_12770_12796 = state_12748__$1;
(statearr_12770_12796[(2)] = null);

(statearr_12770_12796[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___12782,out))
;
return ((function (switch__8768__auto__,c__9975__auto___12782,out){
return (function() {
var cljs$core$async$state_machine__8769__auto__ = null;
var cljs$core$async$state_machine__8769__auto____0 = (function (){
var statearr_12774 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12774[(0)] = cljs$core$async$state_machine__8769__auto__);

(statearr_12774[(1)] = (1));

return statearr_12774;
});
var cljs$core$async$state_machine__8769__auto____1 = (function (state_12748){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_12748);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e12775){if((e12775 instanceof Object)){
var ex__8772__auto__ = e12775;
var statearr_12776_12797 = state_12748;
(statearr_12776_12797[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12748);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12775;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12798 = state_12748;
state_12748 = G__12798;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
cljs$core$async$state_machine__8769__auto__ = function(state_12748){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__8769__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__8769__auto____1.call(this,state_12748);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__8769__auto____0;
cljs$core$async$state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__8769__auto____1;
return cljs$core$async$state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___12782,out))
})();
var state__9977__auto__ = (function (){var statearr_12777 = f__9976__auto__.call(null);
(statearr_12777[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___12782);

return statearr_12777;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___12782,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;


//# sourceMappingURL=async.js.map?rel=1499873945914